(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, allowDevAccounts, sendReferralProgramNotification, roleAssignmentPattern, SandstormDb, appName, addStaticAsset, userPictureUrl, fetchPicture;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file defines the database schema.                                                                              //
                                                                                                                       //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         //
// query it makes, so you can see if it's doing queries too often, etc.                                                //
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  (function () {                                                                                                       // 21
    var oldFind = Mongo.Collection.prototype.find;                                                                     // 22
    Mongo.Collection.prototype.find = function () {                                                                    // 23
      console.log(this._prefix, arguments);                                                                            // 24
      return oldFind.apply(this, arguments);                                                                           // 25
    };                                                                                                                 // 26
  })();                                                                                                                // 21
}                                                                                                                      // 27
                                                                                                                       //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                      //
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
}                                                                                                                      // 34
                                                                                                                       //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                            //
                                                                                                                       //
// Users = new Mongo.Collection("users");                                                                              //
// The users collection is special and can be accessed through `Meteor.users`.                                         //
// See https://docs.meteor.com/#/full/meteor_users.                                                                    //
//                                                                                                                     //
// There are two distinct types of entries in the users collection: identities and accounts. An                        //
// identity contains personal profile information and typically includes some intrinsic method for                     //
// authenticating as the owner of that information.                                                                    //
//                                                                                                                     //
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           //
// Each account can have multiple identities linked to it. To log in as an account you must first                      //
// authenticate as one of its linked identities.                                                                       //
//                                                                                                                     //
// Every user contains the following fields:                                                                           //
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         //
//        stable SHA-256 ID of this identity, hex-encoded.                                                             //
//   createdAt: Date when this entry was added to the collection.                                                      //
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                //
//   services: Object containing login data used by Meteor authentication services.                                    //
//   expires: Date when this user should be deleted. Only present for demo users.                                      //
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        //
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   //
//                     rather than as a Date object. We should fix that.                                               //
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     //
//              link. This field contains the app ID of the app that the user started out demoing.                     //
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      //
//              being a demo user.                                                                                     //
//                                                                                                                     //
// Identity users additionally contain the following fields:                                                           //
//   profile: Object containing the data that will be shared with users and grains that come into                      //
//            contact with this identity. Includes the following fields:                                               //
//       service: String containing the name of this identity's authentication method.                                 //
//       name: String containing the chosen display name of the identity.                                              //
//       handle: String containing the identity's preferred handle.                                                    //
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          //
//                an identicon will be used.                                                                           //
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      //
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          //
//   referredBy: ID of the Account that referred this Identity.                                                        //
//                                                                                                                     //
// Account users additionally contain the following fields:                                                            //
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       //
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             //
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      //
//                       a separate array here so that we can use a Mongo index to enforce the                         //
//                       invariant that an identity only be a login identity for a single account.                     //
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   //
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        //
//                 to do this checking automatically.                                                                  //
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  //
//   signupKey: If this is an invited user, then this field contains their signup key.                                 //
//   signupNote: If the user was invited through a link, then this field contains the note that the                    //
//               inviter admin attached to the key.                                                                    //
//   signupEmail: If the user was invited by email, then this field contains the email address that                    //
//                the invite was sent to.                                                                              //
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    //
//                       terms of service.                                                                             //
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       //
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       //
//              module writes data here; we merely read it. Missing fields should be treated as                        //
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           //
//              TODO(cleanup): Use for referral bonus too.                                                             //
//   storageUsage: Number of bytes this user is currently storing.                                                     //
//   payments: Object defined by payments module, if loaded.                                                           //
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 //
//   accessRequests: Object containing the following fields; used to limit spam.                                       //
//       count: Number of "request access" emails during sent during the current interval.                             //
//       resetOn: Date when the count should be reset.                                                                 //
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              //
//                        stop writing new referredBy values onto Identities for this account.                         //
//   referredCompleteDate: The Date at which the completed referral occurred.                                          //
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        //
//                        reliably determining which Identity's names are safe to display.                             //
//   experiments: Object where each field is an experiment that the user is in, and each value                         //
//           is the parameters for that experiment. Typically, the value simply names which                            //
//           experiment group which the user is in, where "control" is one group. If an experiment                     //
//           is not listed, then the user should not be considered at all for the purpose of that                      //
//           experiment. Each experiment may define a point in time where users not already in the                     //
//           experiment may be added to it and assigned to a group (for example, at user creation                      //
//           time). Current experiments:                                                                               //
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                         //
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                       //
//               test group will see a plan selection dialog and asked to make an explitic choice                      //
//               (possibly "free") before they can create grains (but not when opening someone                         //
//               else's shared grain). The goal of the experiment is to determine whether this                         //
//               prompt scares users away -- and also whether it increases paid signups.                               //
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       //
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              //
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                              // 126
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                       // 127
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                    // 128
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                      // 129
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                              // 130
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                      // 131
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                      // 132
                                                                                                                       //
// TODO(cleanup): This index is obsolete; delete it.                                                                   //
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                           // 135
                                                                                                                       //
Packages = new Mongo.Collection("packages");                                                                           // 137
// Packages which are installed or downloading.                                                                        //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    //
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   //
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                //
//       >1 = download byte count.                                                                                     //
//   error:  If status is "failed", error message string.                                                              //
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          //
//   appId:  If status is "ready", the application ID string.  Packages representing different                         //
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         //
//       and can cryptographically verify that a package belongs to a particular app ID.                               //
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        //
//       collector should at some point check whether there are any other references and, if not,                      //
//       delete the package.                                                                                           //
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         //
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    //
//     even if it has no users.                                                                                        //
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           //
//     packager.                                                                                                       //
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages");                                                                     // 159
// List of packages currently made available via the dev tools running on the local machine.                           //
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     //
// on the local machine to publish an under-development app to this server. That should only ever                      //
// happen on developers' desktop machines.                                                                             //
//                                                                                                                     //
// While a dev package is published, it automatically appears as installed by every user of the                        //
// server, and it overrides all packages with the same application ID. If any instances of those                       //
// packages are currently open, they are killed and reset on publish.                                                  //
//                                                                                                                     //
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     //
// are again killed and refreshed.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  The package ID string (as with Packages._id).                                                               //
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  //
//   timestamp:  Time when the package was last updated. If this changes while the package is                          //
//     published, all running instances are reset. This is used e.g. to reset the app each time                        //
//     changes are made to the source code.                                                                            //
//   manifest:  The app's manifest, as with Packages.manifest.                                                         //
                                                                                                                       //
UserActions = new Mongo.Collection("userActions");                                                                     // 180
// List of actions that each user has installed which create new grains.  Each app may install                         //
// some number of actions (usually, one).                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   userId:  Account ID of the user who has installed this action.                                                    //
//   packageId:  Package used to run this action.                                                                      //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 //
//       that clients can access it without subscribing to the Packages collection.                                    //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               //
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     //
//       `{defaultText: "New Spreadsheet"}`.                                                                           //
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        //
//   command:  Manifest.Command to run this action (see package.capnp).                                                //
                                                                                                                       //
Grains = new Mongo.Collection("grains");                                                                               // 199
// Grains belonging to users.                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   packageId:  _id of the package of which this grain is an instance.                                                //
//   packageSalt: If present, a random string that will used in session ID generation. This field                      //
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            //
//       clients with active sessions.                                                                                 //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   userId: The _id of the account that owns this grain.                                                              //
//   identityId: The identity with which the owning account prefers to open this grain.                                //
//   title:  Human-readable string title, as chosen by the user.                                                       //
//   lastUsed:  Date when the grain was last used by a user.                                                           //
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    //
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    //
//                   time a session to this grain was opened.                                                          //
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       //
//            this date, the grain will be automatically deleted.                                                      //
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        //
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        //
//   size: On-disk size of the grain in bytes.                                                                         //
//                                                                                                                     //
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     //
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      //
// is implemented.                                                                                                     //
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     //
//       web publishing. This field is initialized when first requested by the app.                                    //
                                                                                                                       //
RoleAssignments = new Mongo.Collection("roleAssignments");                                                             // 230
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                    //
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             //
// collection.                                                                                                         //
                                                                                                                       //
Contacts = new Mongo.Collection("contacts");                                                                           // 235
// Edges in the social graph.                                                                                          //
//                                                                                                                     //
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         //
// will show up in her user-picker UI for actions like share-by-identity.                                              //
//                                                                                                                     //
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        //
// Bob's.                                                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: random                                                                                                       //
//   ownerId: The accountId of the user account who owns this contact.                                                 //
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        //
//            the contact to the owner.                                                                                //
//   created: Date when this contact was created.                                                                      //
//   identityId: The `_id` of the user whose contact info this contains.                                               //
                                                                                                                       //
Sessions = new Mongo.Collection("sessions");                                                                           // 252
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     //
//       client, and the grain's `packageSalt`.                                                                        //
//   grainId:  _id of the grain to which this session is connected.                                                    //
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     //
//       '*' in WILDCARD_HOST.                                                                                         //
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         //
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      //
//       have the same `tabId` as the outer session.                                                                   //
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        //
//       period.                                                                                                       //
//   userId:  Account ID of the user who owns this session.                                                            //
//   identityId:  Identity ID of the user who owns this session.                                                       //
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      //
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         //
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     //
//       are present.                                                                                                  //
//   powerboxView: If present, this is a view that should be presented as part of a powerbox                           //
//       interaction.                                                                                                  //
//     offer: The webkey that corresponds to cap that was passed to the `offer` RPC.                                   //
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     //
//       until newSession is called on the UiView.                                                                     //
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        //
//       until newSession is called on the UiView.                                                                     //
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   //
//       request                                                                                                       //
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys");                                                                       // 282
// Invite keys which may be used by users to get access to Sandstorm.                                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   used:  Boolean indicating whether this key has already been consumed.                                             //
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          //
//   email: If this key was sent as an email invite, the email address to which it was sent.                           //
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats");                                                                 // 291
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   timestamp: Date when measurements were taken.                                                                     //
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   //
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           //
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           //
//                                                                                                                     //
// Each of daily, weekly, and monthly contains:                                                                        //
//   activeUsers: The number of unique users who have used a grain on the server in the time                           //
//       interval. Only counts logged-in users.                                                                        //
//   demoUsers: Demo users.                                                                                            //
//   appDemoUsers: Users that came in through "app demo".                                                              //
//   activeGrains: The number of unique grains that have been used in the time interval.                               //
//   apps: An object indexed by app ID recording, for each app:                                                        //
//       owners: Number of unique owners of this app (counting only grains that still exist).                          //
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    //
//         only grains that still exist).                                                                              //
//       grains: Number of active grains of this app (that still exist).                                               //
//       deleted: Number of non-demo grains of this app that were deleted.                                             //
//       demoed: Number of demo grains created and expired.                                                            //
//       appDemoUsers: Number of app demos initiated with this app.                                                    //
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats");                                                                     // 315
// Contains records of objects that were deleted, for stat-keeping purposes.                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             //
//   lastActive: Date of the user's or grain's last activity.                                                          //
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     //
//     arrived to demo. For others, undefined.                                                                         //
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens");                                                                       // 324
// Tokens corresponding to backup files that are currently stored on the server. A user receives                       //
// a token when they create a backup file (either by uploading it, or by backing up one of their                       //
// grains) and may use the token to read the file (either to download it, or to restore a new                          //
// grain from it).                                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The unguessable token string.                                                                          //
//   name:      Suggested filename.                                                                                    //
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        //
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens");                                                                         // 335
// Access tokens for APIs exported by apps.                                                                            //
//                                                                                                                     //
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      //
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      //
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           //
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         //
// `MainView`) -- the fields of type `Data` are API tokens.                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           //
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      //
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       //
//              That is, the UiView's newSession() method will intersect the requested permissions                     //
//              with this identity's permissions before forwarding on to the underlying app. If                        //
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     //
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        //
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     //
//              this is NOT the identity against which the `requiredPermissions` parameter of                          //
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   //
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    //
//              that created the token.                                                                                //
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         //
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    //
//              permissions will be intersected with those held by `identityId` when the view is                       //
//              opened.                                                                                                //
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    //
//              anonymous rather than as directly associated with `identityId`. This has no effect                     //
//              on the permissions granted.                                                                            //
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      //
//              the app or its supervisor (whereas without this it strictly represents UiView).                        //
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      //
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             //
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               //
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    //
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    //
//              containing exactly one of the following fields:                                                        //
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    //
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           //
//                           `Notifications` collection.                                                               //
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      //
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      //
//                  database when that happens. This field contains the boolean true to signify that                   //
//                  it has been set.                                                                                   //
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     //
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           //
//                      value is an object containing the fields `id` and `services`. `id` is the                      //
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             //
//                      powerbox query for matching verified emails. `services` is a                                   //
//                      list of names of identity providers that are trusted to verify addresses.                      //
//                      If `services` is omitted or falsy, all configured identity providers are                       //
//                      trusted. Note that a malicious user could specify invalid names in the                         //
//                      list; they should be ignored.                                                                  //
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               //
//                      An object containing `verifierId`, `tabId`, and `address`.                                     //
//       identity: An Identity capability. The field is the identity ID.                                               //
//   parentToken: If present, then this token represents exactly the capability represented by                         //
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    //
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       //
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       //
//              is set to the identity that shared the view, and `accountId` is set to the account                     //
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             //
//              `parentToken` is present.                                                                              //
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          //
//              revocation. This should be displayed when visualizing incoming capabilities to                         //
//              the grain identified by `grainId`.                                                                     //
//   created:   Date when this token was created.                                                                      //
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    //
//              become un-revoked in the future.                                                                       //
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     //
//              this date, the token will be automatically deleted.                                                    //
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     //
//   lastUsed:  Optional Date when this token was last used.                                                           //
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             //
//              as passed to the `save()` call that created this token. If not present, treat                          //
//              as `webkey` (the default for `ApiTokenOwner`).                                                         //
//   expiresIfUnused:                                                                                                  //
//              Optional Date after which the token, if it has not been used yet, expires.                             //
//              This field should be cleared on a token's first use.                                                   //
//   requirements: List of conditions which must hold for this token to be considered valid.                           //
//              Semantically, this list specifies the powers which were *used* to originally                           //
//              create the token. If any condition in the list becomes untrue, then the token must                     //
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         //
//              through it must also become revoked. Each item is the JSON serialization of the                        //
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         //
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          //
//              cleaned up when the token is.                                                                          //
//                                                                                                                     //
// It is important to note that a token's owner and provider are independent from each other. To                       //
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    //
//                                                                                                                     //
// struct ApiToken {                                                                                                   //
//   owner :ApiTokenOwner;                                                                                             //
//   provider :union {                                                                                                 //
//     grain :group {                                                                                                  //
//       grainId :Text;                                                                                                //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment;                                                                           //
//           forSharing :Bool;                                                                                         //
//         }                                                                                                           //
//         objectId :SupervisorObjectId;                                                                               //
//       }                                                                                                             //
//     }                                                                                                               //
//     frontendRef :union {                                                                                            //
//       notificationHandle :Text;                                                                                     //
//       ipNetwork :Bool;                                                                                              //
//       ipInterface :Bool;                                                                                            //
//       emailVerifier :group {                                                                                        //
//         id :Text;                                                                                                   //
//         services :List(String);                                                                                     //
//       }                                                                                                             //
//       verifiedEmail :group {                                                                                        //
//         verifierId :Text;                                                                                           //
//         tabId :Text;                                                                                                //
//         address :Text;                                                                                              //
//       }                                                                                                             //
//       identity :Text;                                                                                               //
//     }                                                                                                               //
//     child :group {                                                                                                  //
//       parentToken :Text;                                                                                            //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           grainId :Text;                                                                                            //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        //
//         }                                                                                                           //
//         other :Void;                                                                                                //
//       }                                                                                                             //
//     }                                                                                                               //
//   }                                                                                                                 //
//   requirements: List(Supervisor.MembraneRequirement);                                                               //
//   ...                                                                                                               //
// }                                                                                                                   //
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", { sparse: 1 });                                                               // 471
ApiTokens.ensureIndexOnServer("owner.user.identityId", { sparse: 1 });                                                 // 472
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", { sparse: 1 });                                          // 473
                                                                                                                       //
ApiHosts = new Mongo.Collection("apiHosts");                                                                           // 475
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                    //
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      //
// to probe an API host without authentication to determine capabilities such as DAV protocols                         //
// supported, before authenticating to perform real requests. An app can specify these properties                      //
// when creating an offerTemplate.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             //
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     //
//                 up when ApiTokens are deleted.                                                                      //
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          //
//                 This is an object containing fields:                                                                //
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             //
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 //
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        //
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      //
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          //
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          //
//                 fields:                                                                                             //
//     type:       Content-Type.                                                                                       //
//     language:   Content-Language.                                                                                   //
//     encoding:   Content-Encoding.                                                                                   //
//     body:       Entity-body as a string or buffer.                                                                  //
                                                                                                                       //
Notifications = new Mongo.Collection("notifications");                                                                 // 500
// Notifications for a user.                                                                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   grainId:      The grain originating this notification, if any.                                                    //
//   userId:       Account ID of the user receiving the notification.                                                  //
//   text:         The JSON-ified LocalizedText to display in the notification.                                        //
//   isUnread:     Boolean indicating if this notification is unread.                                                  //
//   timestamp:    Date when this notification was last updated                                                        //
//   eventType:    If this notification is due to an activity event, this is the numeric index                         //
//                 of the event type on the grain's ViewInfo.                                                          //
//   count:        The number of times this exact event has repeated. Identical events are                             //
//                 aggregated by incrementing the count.                                                               //
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      //
//   path:         Path inside the grain to which the user should be directed if they click on                         //
//                 the notification.                                                                                   //
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             //
//                 ApiToken referencing the `OngoingNotification` capability.                                          //
//   admin:        If present, this is a notification intended for an admin.                                           //
//     action:     If present, this is a (string) link that the notification should direct the                         //
//                 admin to.                                                                                           //
//     type:       The type of notification (currently only "reportStats").                                            //
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     //
//                 as keys.                                                                                            //
//     $appId:     The appId that has an outstanding update.                                                           //
//       packageId: The packageId that it will update to.                                                              //
//       name: The name of the app. (appTitle from package.manifest)                                                   //
//       version: The app's version number. (appVersion from package.manifest)                                         //
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           //
//   referral:     If this boolean field is true, then treat this notification as a referral                           //
//                 notification. This causes text to be ignored, since we need custom logic.                           //
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      //
//                 a one-time notification only to Oasis users who existed when the bonus program                      //
//                 was implemented.                                                                                    //
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions");                                                 // 536
// Activity events to which a user is subscribed.                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   identityId:   Who is subscribed.                                                                                  //
//   grainId:      Grain to which subscription applies.                                                                //
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       //
//                 whole grain.                                                                                        //
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         //
//                 This allows is useful to express:                                                                   //
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  //
//                 - The owner of a grain does not want notifications (normally, they are                              //
//                   implicitly subscribed).                                                                           //
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      //
//                   which they comment, so they mute the grain.                                                       //
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 553
ActivitySubscriptions.ensureIndexOnServer({ "grainId": 1, "threadPath": 1 });                                          // 554
                                                                                                                       //
StatsTokens = new Mongo.Collection("statsTokens");                                                                     // 556
// Access tokens for the Stats collection                                                                              //
//                                                                                                                     //
// These tokens are used for accessing the ActivityStats collection remotely                                           //
// (ie. from a dashboard webapp)                                                                                       //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  //
                                                                                                                       //
Misc = new Mongo.Collection("misc");                                                                                   // 565
// Miscellaneous configuration and other settings                                                                      //
//                                                                                                                     //
// This table is currently only used for persisting BASE_URL from one session to the next,                             //
// but in general any miscellaneous settings should go in here                                                         //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "BASE_URL"                                                                //
//   value:     The value of the setting.                                                                              //
                                                                                                                       //
Settings = new Mongo.Collection("settings");                                                                           // 575
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                         //
// route. This collection differs from misc in that any admin user can update it through the admin                     //
// interface.                                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "smtpConfig"                                                              //
//   value:     The value of the setting.                                                                              //
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     //
//                       so, it will also write an object to this field indicating why the reset was                   //
//                       needed. That object can have the following variants:                                          //
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      //
//                           with the old BASE_URL.                                                                    //
//   preinstalledApps: A list of objects:                                                                              //
//     appId: The Packages.appId of the app to install                                                                 //
//     status: packageId                                                                                               //
//     packageId: The Packages._id of the app to install                                                               //
//                                                                                                                     //
//   potentially other fields that are unique to the setting                                                           //
                                                                                                                       //
Migrations = new Mongo.Collection("migrations");                                                                       // 595
// This table tracks which migrations we have applied to this instance.                                                //
// It contains a single entry:                                                                                         //
//   _id:       "migrations_applied"                                                                                   //
//   value:     The number of migrations this instance has successfully completed.                                     //
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets");                                                                   // 601
// Collection of static assets served up from the Sandstorm server's "static" host. We only                            //
// support relatively small assets: under 1MB each.                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID; will be used in the URL.                                                                    //
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            //
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              //
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    //
//   content:   The asset content (byte buffer).                                                                       //
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    //
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        //
//       to catch leaked assets, although it's probably not a big deal in practice.                                    //
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens");                                                         // 615
// Collection of tokens representing a single-use permission to upload an asset, such as a new                         //
// profile picture.                                                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID.                                                                                             //
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 //
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          //
//           userId: Account ID of user whose picture shall be replaced.                                               //
//           identityId: Which of the user's identities shall be updated.                                              //
//   expires:   Time when this token will go away if unused.                                                           //
                                                                                                                       //
Plans = new Mongo.Collection("plans");                                                                                 // 627
// Subscription plans, which determine quota.                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                //
//   storage: Number of bytes this user is allowed to store.                                                           //
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          //
//   computeLabel: Label to display to the user describing this plan's compute units.                                  //
//   grains: Total number of grains this user can create (often `Infinity`).                                           //
//   price: Price per month in US cents.                                                                               //
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           //
//       allowed to switch away.                                                                                       //
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      //
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex");                                                                           // 641
// A mirror of the data from the App Market index                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: the appId of the app                                                                                         //
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    //
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles");                                                             // 648
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                     //
// by that user is installed, as well as if the keybase profile is requested and not already                           //
// present for some reason.                                                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   //
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    //
//   handle: Keybase handle.                                                                                           //
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      //
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         //
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          //
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     //
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     //
//     server is currently actively checking this proof). Note that if a check fails due to network                    //
//     errors, the status goes back to "unverified".                                                                   //
//                                                                                                                     //
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          //
//       for now and we just trust Keybase.                                                                            //
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey");                                                                       // 668
// Responsible for storing the current feature key that is active on the server.  Contains a single                    //
// document with two keys:                                                                                             //
//                                                                                                                     //
//   _id: "currentFeatureKey"                                                                                          //
//   value: the still-signed, binary-encoded feature key                                                               //
//          (a feature key with comments removed and base64 decoded)                                                   //
//                                                                                                                     //
// This is only intended to be visible on the server.                                                                  //
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession");                                                                   // 678
// Responsible for storing information about setup sessions.  Contains a single document with three                    //
// keys:                                                                                                               //
//                                                                                                                     //
//   _id: "current-session"                                                                                            //
//   creationDate: Date object indicating when this session was created.                                               //
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              //
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications");                                               // 686
// Responsible for very short-lived queueing of desktop notification information.                                      //
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        //
// odd in that it is intended primarily for edge-triggered communications, but                                         //
// Meteor's collections aren't really designed to support that organization.                                           //
// Fields for each :                                                                                                   //
//                                                                                                                     //
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            //
//   creationDate: Date object. indicating when this notification was posted.                                          //
//   userId: String. Account id to which this notification was published.                                              //
//   notificationId: String.  ID of the matching event in the Notifications table to dismiss if this                   //
//                            notification is activated.                                                               //
//   appActivity: Object with fields:                                                                                  //
//     user: {               The user whose action caused this notification.                                           //
//       name: String,       The user's display name.                                                                  //
//       avatarUrl: String,  The URL for the user's profile picture.                                                   //
//     },                                                                                                              //
//     grainId: String,      Which grain this action took place on                                                     //
//     path: String,         The path of the notification.                                                             //
//     body: Util.LocalizedText,  The main body of the activity event.                                                 //
//     actionText: Util.LocalizedText, What action the user took, e.g.                                                 //
//                                     { defaultText: "added a comment" }                                              //
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 709
  Meteor.publish("credentials", function () {                                                                          // 710
    // Data needed for isSignedUp() and isAdmin() to work.                                                             //
                                                                                                                       //
    if (this.userId) {                                                                                                 // 713
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                                // 717
          referredIdentityIds: 1, cachedStorageQuota: 1 } }), Plans.find()];                                           // 718
    } else {                                                                                                           // 721
      return [];                                                                                                       // 722
    }                                                                                                                  // 723
  });                                                                                                                  // 724
}                                                                                                                      // 725
                                                                                                                       //
var countReferrals = function countReferrals(user) {                                                                   // 727
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 728
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 729
};                                                                                                                     // 730
                                                                                                                       //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                   // 732
  // This function returns an object of the form:                                                                      //
  //                                                                                                                   //
  // - {grains: 0, storage: 0}                                                                                         //
  //                                                                                                                   //
  // which are extra resources this account gets as part of participating in the referral                              //
  // program. (Storage is measured in bytes, as usual for plans.)                                                      //
                                                                                                                       //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        //
  //   payments-specific) and aggregating into `planBonus`.                                                            //
                                                                                                                       //
  // Authorization note: Only call this if accountId is the current user!                                              //
  var isPaid = user.plan && user.plan !== "free";                                                                      // 744
                                                                                                                       //
  successfulReferralsCount = countReferrals(user);                                                                     // 746
  if (isPaid) {                                                                                                        // 747
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 748
    return { grains: 0,                                                                                                // 749
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                    // 750
  } else {                                                                                                             // 753
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 754
    var bonus = {                                                                                                      // 755
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 756
    };                                                                                                                 // 755
    if (successfulReferralsCount > 0) {                                                                                // 760
      bonus.grains = Infinity;                                                                                         // 761
    } else {                                                                                                           // 762
      bonus.grains = 0;                                                                                                // 763
    }                                                                                                                  // 764
                                                                                                                       //
    return bonus;                                                                                                      // 766
  }                                                                                                                    // 767
};                                                                                                                     // 768
                                                                                                                       //
isAdmin = function isAdmin() {                                                                                         // 770
  // Returns true if the user is the administrator.                                                                    //
                                                                                                                       //
  var user = Meteor.user();                                                                                            // 773
  if (user && user.isAdmin) {                                                                                          // 774
    return true;                                                                                                       // 775
  } else {                                                                                                             // 776
    return false;                                                                                                      // 777
  }                                                                                                                    // 778
};                                                                                                                     // 779
                                                                                                                       //
isAdminById = function isAdminById(id) {                                                                               // 781
  // Returns true if the user's id is the administrator.                                                               //
                                                                                                                       //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                            // 784
  if (user && user.isAdmin) {                                                                                          // 785
    return true;                                                                                                       // 786
  } else {                                                                                                             // 787
    return false;                                                                                                      // 788
  }                                                                                                                    // 789
};                                                                                                                     // 790
                                                                                                                       //
findAdminUserForToken = function findAdminUserForToken(token) {                                                        // 792
  if (!token.requirements) {                                                                                           // 793
    return;                                                                                                            // 794
  }                                                                                                                    // 795
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 797
    return "userIsAdmin" in requirement;                                                                               // 798
  });                                                                                                                  // 799
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 801
    return;                                                                                                            // 802
  }                                                                                                                    // 803
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 805
    return;                                                                                                            // 806
  }                                                                                                                    // 807
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 809
};                                                                                                                     // 810
                                                                                                                       //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 812
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 814
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 815
}                                                                                                                      // 816
                                                                                                                       //
matchWildcardHost = function matchWildcardHost(host) {                                                                 // 818
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           //
                                                                                                                       //
  // We remove everything after the first ":" character so that our                                                    //
  // comparison logic ignores port numbers.                                                                            //
  var prefix = wildcardHost[0];                                                                                        // 823
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 824
  var hostSansPort = host.split(":")[0];                                                                               // 825
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 830
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 831
      return id;                                                                                                       // 832
    }                                                                                                                  // 833
  }                                                                                                                    // 834
                                                                                                                       //
  return null;                                                                                                         // 836
};                                                                                                                     // 837
                                                                                                                       //
makeWildcardHost = function makeWildcardHost(id) {                                                                     // 839
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 840
};                                                                                                                     // 841
                                                                                                                       //
var isApiHostId = function isApiHostId(hostId) {                                                                       // 843
  if (hostId) {                                                                                                        // 844
    var split = hostId.split("-");                                                                                     // 845
    if (split[0] === "api") return split[1] || "*";                                                                    // 846
  }                                                                                                                    // 847
                                                                                                                       //
  return false;                                                                                                        // 849
};                                                                                                                     // 850
                                                                                                                       //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                   // 852
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 853
};                                                                                                                     // 854
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 856
if (Meteor.isServer) {                                                                                                 // 857
  (function () {                                                                                                       // 857
    var Crypto = Npm.require("crypto");                                                                                // 858
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                    // 859
      // Given an API token, compute the host ID that must be used when requesting this token.                         //
                                                                                                                       //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                      //
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                     //
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                     //
      // any bugs which would allow someone who knows only the hostname to access the app API.                         //
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                               // 866
    };                                                                                                                 // 867
  })();                                                                                                                // 857
} else {                                                                                                               // 868
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                      // 869
    // Given an API token, compute the host ID that must be used when requesting this token.                           //
                                                                                                                       //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        //
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       //
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       //
    // any bugs which would allow someone who knows only the hostname to access the app API.                           //
    return SHA256("x" + token).slice(0, 32);                                                                           // 876
  };                                                                                                                   // 877
}                                                                                                                      // 878
                                                                                                                       //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                            // 880
  return "api-" + apiHostIdHashForToken(token);                                                                        // 881
};                                                                                                                     // 882
                                                                                                                       //
var makeApiHost = function makeApiHost(token) {                                                                        // 884
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 885
};                                                                                                                     // 886
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 888
  (function () {                                                                                                       // 888
    var Url = Npm.require("url");                                                                                      // 889
    getWildcardOrigin = function getWildcardOrigin() {                                                                 // 890
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                      //
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                    //
      // an astrisk is only allowed as the first character and must be followed by a period. So we need                //
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                   //
      // really do. We also add the protocol to the front (again, that's what CSP wants).                              //
                                                                                                                       //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                 //
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                         // 898
                                                                                                                       //
      var dotPos = wildcardHost[1].indexOf(".");                                                                       // 900
      if (dotPos < 0) {                                                                                                // 901
        return protocol + "//*";                                                                                       // 902
      } else {                                                                                                         // 903
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                       // 904
      }                                                                                                                // 905
    };                                                                                                                 // 906
  })();                                                                                                                // 888
}                                                                                                                      // 907
                                                                                                                       //
allowDevAccounts = function allowDevAccounts() {                                                                       // 909
  var setting = Settings.findOne({ _id: "devAccounts" });                                                              // 910
  if (setting) {                                                                                                       // 911
    return setting.value;                                                                                              // 912
  } else {                                                                                                             // 913
    return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;                 // 914
  }                                                                                                                    // 916
};                                                                                                                     // 917
                                                                                                                       //
sendReferralProgramNotification = function sendReferralProgramNotification(userId) {                                   // 919
  Notifications.upsert({                                                                                               // 920
    userId: userId,                                                                                                    // 921
    referral: true                                                                                                     // 922
  }, {                                                                                                                 // 920
    userId: userId,                                                                                                    // 924
    referral: true,                                                                                                    // 925
    timestamp: new Date(),                                                                                             // 926
    isUnread: true                                                                                                     // 927
  });                                                                                                                  // 923
};                                                                                                                     // 929
                                                                                                                       //
roleAssignmentPattern = {                                                                                              // 931
  none: Match.Optional(null),                                                                                          // 932
  allAccess: Match.Optional(null),                                                                                     // 933
  roleId: Match.Optional(Match.Integer),                                                                               // 934
  addPermissions: Match.Optional([Boolean]),                                                                           // 935
  removePermissions: Match.Optional([Boolean])                                                                         // 936
};                                                                                                                     // 931
                                                                                                                       //
SandstormDb = function SandstormDb(quotaManager) {                                                                     // 939
  // quotaManager is an object with the following method:                                                              //
  //   updateUserQuota: It is provided two arguments                                                                   //
  //     db: This SandstormDb object                                                                                   //
  //     user: A collections.users account object                                                                      //
  //   and returns a quota object:                                                                                     //
  //     storage: A number (can be Infinity)                                                                           //
  //     compute: A number (can be Infinity)                                                                           //
  //     grains: A number (can be Infinity)                                                                            //
                                                                                                                       //
  this.quotaManager = quotaManager;                                                                                    // 949
  this.collections = {                                                                                                 // 950
    // Direct access to underlying collections. DEPRECATED.                                                            //
    //                                                                                                                 //
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      //
    //   direct access to the collections.                                                                             //
                                                                                                                       //
    packages: Packages,                                                                                                // 956
    devPackages: DevPackages,                                                                                          // 957
    userActions: UserActions,                                                                                          // 958
    grains: Grains,                                                                                                    // 959
    contacts: Contacts,                                                                                                // 960
    sessions: Sessions,                                                                                                // 961
    signupKeys: SignupKeys,                                                                                            // 962
    activityStats: ActivityStats,                                                                                      // 963
    deleteStats: DeleteStats,                                                                                          // 964
    fileTokens: FileTokens,                                                                                            // 965
    apiTokens: ApiTokens,                                                                                              // 966
    apiHosts: ApiHosts,                                                                                                // 967
    notifications: Notifications,                                                                                      // 968
    statsTokens: StatsTokens,                                                                                          // 969
    misc: Misc,                                                                                                        // 970
    settings: Settings,                                                                                                // 971
    appIndex: AppIndex,                                                                                                // 972
    keybaseProfiles: KeybaseProfiles,                                                                                  // 973
    featureKey: FeatureKey,                                                                                            // 974
    setupSession: SetupSession,                                                                                        // 975
    users: Meteor.users,                                                                                               // 976
    desktopNotifications: DesktopNotifications                                                                         // 977
                                                                                                                       //
  };                                                                                                                   // 950
};                                                                                                                     // 983
                                                                                                                       //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                           //
//   objects created in SandstormDb's constructor rather than globals.                                                 //
                                                                                                                       //
// Intentionally omitted:                                                                                              //
// - Migrations, since it's used only within this package.                                                             //
// - RoleAssignments, since it is deprecated and only used by the migration that eliminated it.                        //
_.extend(SandstormDb.prototype, {                                                                                      // 988
  isAdmin: isAdmin,                                                                                                    // 989
  isAdminById: isAdminById,                                                                                            // 990
  findAdminUserForToken: findAdminUserForToken,                                                                        // 991
  matchWildcardHost: matchWildcardHost,                                                                                // 992
  makeWildcardHost: makeWildcardHost,                                                                                  // 993
  isApiHostId: isApiHostId,                                                                                            // 994
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 995
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 996
  apiHostIdForToken: apiHostIdForToken,                                                                                // 997
  makeApiHost: makeApiHost,                                                                                            // 998
  allowDevAccounts: allowDevAccounts,                                                                                  // 999
  roleAssignmentPattern: roleAssignmentPattern,                                                                        // 1000
                                                                                                                       //
  isDemoUser: function isDemoUser() {                                                                                  // 1002
    // Returns true if this is a demo user.                                                                            //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1005
    if (user && user.expires) {                                                                                        // 1006
      return true;                                                                                                     // 1007
    } else {                                                                                                           // 1008
      return false;                                                                                                    // 1009
    }                                                                                                                  // 1010
  },                                                                                                                   // 1011
                                                                                                                       //
  isSignedUp: function isSignedUp() {                                                                                  // 1013
    var user = Meteor.user();                                                                                          // 1014
    return this.isAccountSignedUp(user);                                                                               // 1015
  },                                                                                                                   // 1016
                                                                                                                       //
  isAccountSignedUp: function isAccountSignedUp(user) {                                                                // 1018
    // Returns true if the user has presented an invite key.                                                           //
                                                                                                                       //
    if (!user) return false; // not signed in                                                                          // 1021
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1023
                                                                                                                       //
    if (user.expires) return false; // demo user.                                                                      // 1025
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1027
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1029
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1031
                                                                                                                       //
    return false;                                                                                                      // 1033
  },                                                                                                                   // 1034
                                                                                                                       //
  isSignedUpOrDemo: function isSignedUpOrDemo() {                                                                      // 1036
    var user = Meteor.user();                                                                                          // 1037
    return this.isAccountSignedUpOrDemo(user);                                                                         // 1038
  },                                                                                                                   // 1039
                                                                                                                       //
  isAccountSignedUpOrDemo: function isAccountSignedUpOrDemo(user) {                                                    // 1041
    if (!user) return false; // not signed in                                                                          // 1042
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1044
                                                                                                                       //
    if (user.expires) return true; // demo user.                                                                       // 1046
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1048
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1050
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1052
                                                                                                                       //
    return false;                                                                                                      // 1054
  },                                                                                                                   // 1055
                                                                                                                       //
  isIdentityInOrganization: function isIdentityInOrganization(identity) {                                              // 1057
    if (!identity || !identity.services) {                                                                             // 1058
      return false;                                                                                                    // 1059
    }                                                                                                                  // 1060
                                                                                                                       //
    var orgMembership = this.getOrganizationMembership();                                                              // 1062
    var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                         // 1063
    var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                           // 1064
    var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                  // 1065
    var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                    // 1066
    var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                               // 1067
    var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                               // 1068
    if (emailEnabled && emailDomain && identity.services.email) {                                                      // 1069
      if (identity.services.email.email.toLowerCase().split("@").pop() === emailDomain) {                              // 1070
        return true;                                                                                                   // 1071
      }                                                                                                                // 1072
    } else if (ldapEnabled && identity.services.ldap) {                                                                // 1073
      return true;                                                                                                     // 1074
    } else if (samlEnabled && identity.services.saml) {                                                                // 1075
      return true;                                                                                                     // 1076
    } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {             // 1077
      if (identity.services.google.hd.toLowerCase() === googleDomain) {                                                // 1078
        return true;                                                                                                   // 1079
      }                                                                                                                // 1080
    }                                                                                                                  // 1081
                                                                                                                       //
    return false;                                                                                                      // 1083
  },                                                                                                                   // 1084
                                                                                                                       //
  isUserInOrganization: function isUserInOrganization(user) {                                                          // 1086
    if (!this.isFeatureKeyValid()) {                                                                                   // 1087
      return false;                                                                                                    // 1088
    }                                                                                                                  // 1089
                                                                                                                       //
    for (var i = 0; i < user.loginIdentities.length; i++) {                                                            // 1091
      var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                        // 1092
      if (this.isIdentityInOrganization(identity)) {                                                                   // 1093
        return true;                                                                                                   // 1094
      }                                                                                                                // 1095
    }                                                                                                                  // 1096
                                                                                                                       //
    return false;                                                                                                      // 1098
  }                                                                                                                    // 1099
});                                                                                                                    // 988
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1102
  (function () {                                                                                                       // 1102
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                       // 1103
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1105
    SandstormDb.prototype.removeApiTokens = function (query) {                                                         // 1106
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                           //
                                                                                                                       //
      this.collections.apiTokens.find(query).forEach(function (token) {                                                // 1109
        // Clean up ApiHosts for webkey tokens.                                                                        //
        if (token.hasApiHost) {                                                                                        // 1111
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                  // 1112
          ApiHosts.remove({ hash2: hash2 });                                                                           // 1113
        }                                                                                                              // 1114
      });                                                                                                              // 1115
                                                                                                                       //
      this.collections.apiTokens.remove(query);                                                                        // 1117
    };                                                                                                                 // 1118
  })();                                                                                                                // 1102
}                                                                                                                      // 1119
                                                                                                                       //
// TODO(someday): clean this up.  Logic for building static asset urls on client and server                            //
// appears all over the codebase.                                                                                      //
var httpProtocol = void 0;                                                                                             // 1123
if (Meteor.isServer) {                                                                                                 // 1124
  var _Url = Npm.require("url");                                                                                       // 1125
  httpProtocol = _Url.parse(process.env.ROOT_URL).protocol;                                                            // 1126
} else {                                                                                                               // 1127
  httpProtocol = window.location.protocol;                                                                             // 1128
}                                                                                                                      // 1129
                                                                                                                       //
// =======================================================================================                             //
// Below this point are newly-written or refactored functions.                                                         //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1134
  getUser: function getUser(userId) {                                                                                  // 1135
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1136
    if (userId) {                                                                                                      // 1137
      return Meteor.users.findOne(userId);                                                                             // 1138
    }                                                                                                                  // 1139
  },                                                                                                                   // 1140
                                                                                                                       //
  getIdentity: function getIdentity(identityId) {                                                                      // 1142
    check(identityId, String);                                                                                         // 1143
    var identity = Meteor.users.findOne({ _id: identityId });                                                          // 1144
    if (identity) {                                                                                                    // 1145
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 1146
      SandstormDb.fillInIntrinsicName(identity);                                                                       // 1147
      SandstormDb.fillInPictureUrl(identity);                                                                          // 1148
      return identity;                                                                                                 // 1149
    }                                                                                                                  // 1150
  },                                                                                                                   // 1151
                                                                                                                       //
  userHasIdentity: function userHasIdentity(userId, identityId) {                                                      // 1153
    check(userId, String);                                                                                             // 1154
    check(identityId, String);                                                                                         // 1155
                                                                                                                       //
    if (userId === identityId) return true;                                                                            // 1157
                                                                                                                       //
    var user = Meteor.users.findOne(userId);                                                                           // 1159
    return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                             // 1160
  },                                                                                                                   // 1161
                                                                                                                       //
  userGrains: function userGrains(userId, trashed) {                                                                   // 1163
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1164
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1165
                                                                                                                       //
    return this.collections.grains.find({ userId: userId, trashed: { $exists: !!trashed } });                          // 1167
  },                                                                                                                   // 1168
                                                                                                                       //
  currentUserGrains: function currentUserGrains(trashed) {                                                             // 1170
    return this.userGrains(Meteor.userId(), trashed);                                                                  // 1171
  },                                                                                                                   // 1172
                                                                                                                       //
  getGrain: function getGrain(grainId) {                                                                               // 1174
    check(grainId, String);                                                                                            // 1175
    return this.collections.grains.findOne(grainId);                                                                   // 1176
  },                                                                                                                   // 1177
                                                                                                                       //
  userApiTokens: function userApiTokens(userId, trashed) {                                                             // 1179
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1180
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1181
    var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                            // 1182
    return this.collections.apiTokens.find({                                                                           // 1183
      "owner.user.identityId": { $in: identityIds },                                                                   // 1184
      trashed: { $exists: !!trashed }                                                                                  // 1185
    });                                                                                                                // 1183
  },                                                                                                                   // 1187
                                                                                                                       //
  currentUserApiTokens: function currentUserApiTokens(trashed) {                                                       // 1189
    return this.userApiTokens(Meteor.userId(), trashed);                                                               // 1190
  },                                                                                                                   // 1191
                                                                                                                       //
  userActions: function userActions(user) {                                                                            // 1193
    return this.collections.userActions.find({ userId: user });                                                        // 1194
  },                                                                                                                   // 1195
                                                                                                                       //
  currentUserActions: function currentUserActions() {                                                                  // 1197
    return this.userActions(Meteor.userId());                                                                          // 1198
  },                                                                                                                   // 1199
                                                                                                                       //
  iconSrcForPackage: function iconSrcForPackage(pkg, usage) {                                                          // 1201
    return Identicon.iconSrcForPackage(pkg, usage, httpProtocol + "//" + this.makeWildcardHost("static"));             // 1202
  },                                                                                                                   // 1203
                                                                                                                       //
  getDenormalizedGrainInfo: function getDenormalizedGrainInfo(grainId) {                                               // 1205
    var grain = this.getGrain(grainId);                                                                                // 1206
    var pkg = this.collections.packages.findOne(grain.packageId);                                                      // 1207
                                                                                                                       //
    if (!pkg) {                                                                                                        // 1209
      pkg = this.collections.devPackages.findOne(grain.packageId);                                                     // 1210
    }                                                                                                                  // 1211
                                                                                                                       //
    var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                                // 1213
    var grainInfo = { appTitle: appTitle };                                                                            // 1214
                                                                                                                       //
    if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                                 // 1216
      var icons = pkg.manifest.metadata.icons;                                                                         // 1217
      grainInfo.icon = icons.grain || icons.appGrid;                                                                   // 1218
    }                                                                                                                  // 1219
                                                                                                                       //
    // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                      //
    if (!grainInfo.icon && pkg) {                                                                                      // 1222
      grainInfo.appId = pkg.appId;                                                                                     // 1223
    }                                                                                                                  // 1224
                                                                                                                       //
    return grainInfo;                                                                                                  // 1226
  },                                                                                                                   // 1227
                                                                                                                       //
  getPlan: function getPlan(id) {                                                                                      // 1229
    check(id, String);                                                                                                 // 1230
    var plan = Plans.findOne(id);                                                                                      // 1231
    if (!plan) {                                                                                                       // 1232
      throw new Error("no such plan: " + id);                                                                          // 1233
    }                                                                                                                  // 1234
                                                                                                                       //
    return plan;                                                                                                       // 1236
  },                                                                                                                   // 1237
                                                                                                                       //
  listPlans: function listPlans() {                                                                                    // 1239
    return Plans.find({}, { sort: { price: 1 } });                                                                     // 1240
  },                                                                                                                   // 1241
                                                                                                                       //
  getMyPlan: function getMyPlan() {                                                                                    // 1243
    var user = Meteor.user();                                                                                          // 1244
    return user && Plans.findOne(user.plan || "free");                                                                 // 1245
  },                                                                                                                   // 1246
                                                                                                                       //
  getMyReferralBonus: function getMyReferralBonus(user) {                                                              // 1248
    // This function is called from the server and from the client, similar to getMyPlan().                            //
    //                                                                                                                 //
    // The parameter may be omitted in which case the current user is assumed.                                         //
                                                                                                                       //
    return calculateReferralBonus(user || Meteor.user());                                                              // 1253
  },                                                                                                                   // 1254
                                                                                                                       //
  getMyUsage: function getMyUsage(user) {                                                                              // 1256
    user = user || Meteor.user();                                                                                      // 1257
    if (user && (Meteor.isServer || user.pseudoUsage)) {                                                               // 1258
      if (Meteor.isClient) {                                                                                           // 1259
        // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                       //
        // not reactive.                                                                                               //
        return user.pseudoUsage;                                                                                       // 1262
      } else {                                                                                                         // 1263
        return {                                                                                                       // 1264
          grains: Grains.find({ userId: user._id }).count(),                                                           // 1265
          storage: user.storageUsage || 0,                                                                             // 1266
          compute: 0 };                                                                                                // 1267
      }                                                                                                                // 1269
    } else // not tracked yet                                                                                          // 1270
      {                                                                                                                // 1270
        return { grains: 0, storage: 0, compute: 0 };                                                                  // 1271
      }                                                                                                                // 1272
  },                                                                                                                   // 1273
                                                                                                                       //
  isUninvitedFreeUser: function isUninvitedFreeUser() {                                                                // 1275
    if (!Meteor.settings["public"].allowUninvited) return false;                                                       // 1276
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1278
    return user && !user.expires && (!user.plan || user.plan === "free");                                              // 1279
  },                                                                                                                   // 1280
                                                                                                                       //
  getSetting: function getSetting(name) {                                                                              // 1282
    var setting = Settings.findOne(name);                                                                              // 1283
    return setting && setting.value;                                                                                   // 1284
  },                                                                                                                   // 1285
                                                                                                                       //
  getSettingWithFallback: function getSettingWithFallback(name, fallbackValue) {                                       // 1287
    var value = this.getSetting(name);                                                                                 // 1288
    if (value === undefined) {                                                                                         // 1289
      return fallbackValue;                                                                                            // 1290
    }                                                                                                                  // 1291
                                                                                                                       //
    return value;                                                                                                      // 1293
  },                                                                                                                   // 1294
                                                                                                                       //
  addUserActions: function addUserActions(userId, packageId, simulation) {                                             // 1296
    check(userId, String);                                                                                             // 1297
    check(packageId, String);                                                                                          // 1298
                                                                                                                       //
    var pack = Packages.findOne({ _id: packageId });                                                                   // 1300
    if (pack) {                                                                                                        // 1301
      // Remove old versions.                                                                                          //
      var numRemoved = UserActions.remove({ userId: userId, appId: pack.appId });                                      // 1303
                                                                                                                       //
      // Install new.                                                                                                  //
      var actions = pack.manifest.actions;                                                                             // 1306
      for (var i in actions) {                                                                                         // 1307
        var action = actions[i];                                                                                       // 1308
        if ("none" in action.input) {                                                                                  // 1309
          var userAction = {                                                                                           // 1310
            userId: userId,                                                                                            // 1311
            packageId: pack._id,                                                                                       // 1312
            appId: pack.appId,                                                                                         // 1313
            appTitle: pack.manifest.appTitle,                                                                          // 1314
            appMarketingVersion: pack.manifest.appMarketingVersion,                                                    // 1315
            appVersion: pack.manifest.appVersion,                                                                      // 1316
            title: action.title,                                                                                       // 1317
            nounPhrase: action.nounPhrase,                                                                             // 1318
            command: action.command                                                                                    // 1319
          };                                                                                                           // 1310
          UserActions.insert(userAction);                                                                              // 1321
        } else {                                                                                                       // 1322
          // TODO(someday):  Implement actions with capability inputs.                                                 //
        }                                                                                                              // 1324
      }                                                                                                                // 1325
                                                                                                                       //
      if (numRemoved > 0 && !simulation) {                                                                             // 1327
        this.deleteUnusedPackages(pack.appId);                                                                         // 1328
      }                                                                                                                // 1329
    }                                                                                                                  // 1330
  },                                                                                                                   // 1331
                                                                                                                       //
  sendAdminNotification: function sendAdminNotification(message, link) {                                               // 1333
    Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                             // 1334
      Notifications.insert({                                                                                           // 1335
        admin: {                                                                                                       // 1336
          action: link,                                                                                                // 1337
          type: "reportStats"                                                                                          // 1338
        },                                                                                                             // 1336
        userId: user._id,                                                                                              // 1340
        text: { defaultText: message },                                                                                // 1341
        timestamp: new Date(),                                                                                         // 1342
        isUnread: true                                                                                                 // 1343
      });                                                                                                              // 1335
    });                                                                                                                // 1345
  },                                                                                                                   // 1346
                                                                                                                       //
  getKeybaseProfile: function getKeybaseProfile(keyFingerprint) {                                                      // 1348
    return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                             // 1349
  },                                                                                                                   // 1350
                                                                                                                       //
  getServerTitle: function getServerTitle() {                                                                          // 1352
    var setting = Settings.findOne({ _id: "serverTitle" });                                                            // 1353
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1354
  },                                                                                                                   // 1355
                                                                                                                       //
  getSmtpConfig: function getSmtpConfig() {                                                                            // 1357
    var setting = Settings.findOne({ _id: "smtpConfig" });                                                             // 1358
    return setting ? setting.value : undefined; // undefined if subscription is not ready.                             // 1359
  },                                                                                                                   // 1360
                                                                                                                       //
                                                                                                                       //
  getReturnAddress: function getReturnAddress() {                                                                      // 1362
    var config = this.getSmtpConfig();                                                                                 // 1363
    return config && config.returnAddress || ""; // empty if subscription is not ready.                                // 1364
  },                                                                                                                   // 1365
                                                                                                                       //
  getReturnAddressWithDisplayName: function getReturnAddressWithDisplayName(identityId) {                              // 1367
    check(identityId, String);                                                                                         // 1368
    var identity = this.getIdentity(identityId);                                                                       // 1369
    var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                                  // 1370
                                                                                                                       //
    // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                            //
    // we could escape such characters with a backslash, but that does not seem to help here.                          //
    var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                           // 1374
                                                                                                                       //
    return "\"" + sanitized + "\" <" + this.getReturnAddress() + ">";                                                  // 1376
  },                                                                                                                   // 1377
                                                                                                                       //
  getPrimaryEmail: function getPrimaryEmail(accountId, identityId) {                                                   // 1379
    check(accountId, String);                                                                                          // 1380
    check(identityId, String);                                                                                         // 1381
                                                                                                                       //
    var identity = this.getIdentity(identityId);                                                                       // 1383
    var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                        // 1384
    var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                             // 1385
    var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                             // 1386
    if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                            // 1387
      return accountPrimaryEmailAddress;                                                                               // 1388
    } else if (senderPrimaryEmail) {                                                                                   // 1389
      return senderPrimaryEmail.email;                                                                                 // 1390
    } else {                                                                                                           // 1391
      return null;                                                                                                     // 1392
    }                                                                                                                  // 1393
  },                                                                                                                   // 1394
                                                                                                                       //
  incrementDailySentMailCount: function incrementDailySentMailCount(accountId) {                                       // 1396
    check(accountId, String);                                                                                          // 1397
                                                                                                                       //
    var DAILY_LIMIT = 50;                                                                                              // 1399
    var result = Meteor.users.findAndModify({                                                                          // 1400
      query: { _id: accountId },                                                                                       // 1401
      update: {                                                                                                        // 1402
        $inc: {                                                                                                        // 1403
          dailySentMailCount: 1                                                                                        // 1404
        }                                                                                                              // 1403
      },                                                                                                               // 1402
      fields: { dailySentMailCount: 1 }                                                                                // 1407
    });                                                                                                                // 1400
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 1410
      throw new Error("Couldn't update daily sent mail count.");                                                       // 1411
    }                                                                                                                  // 1412
                                                                                                                       //
    var user = result.value;                                                                                           // 1414
    if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                      // 1415
      throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
    }                                                                                                                  // 1420
  },                                                                                                                   // 1421
                                                                                                                       //
  isFeatureKeyValid: function isFeatureKeyValid() {                                                                    // 1423
    var featureKey = this.currentFeatureKey();                                                                         // 1424
    return !!featureKey;                                                                                               // 1425
  },                                                                                                                   // 1426
                                                                                                                       //
  isFeatureKeyValidAndNotExpired: function isFeatureKeyValidAndNotExpired() {                                          // 1428
    var featureKey = this.currentFeatureKey();                                                                         // 1429
    return featureKey && parseInt(featureKey.expires) > Date.now() / 1000;                                             // 1430
  },                                                                                                                   // 1431
                                                                                                                       //
  getLdapUrl: function getLdapUrl() {                                                                                  // 1433
    var setting = Settings.findOne({ _id: "ldapUrl" });                                                                // 1434
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1435
  },                                                                                                                   // 1436
                                                                                                                       //
  getLdapBase: function getLdapBase() {                                                                                // 1438
    var setting = Settings.findOne({ _id: "ldapBase" });                                                               // 1439
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1440
  },                                                                                                                   // 1441
                                                                                                                       //
  getLdapDnPattern: function getLdapDnPattern() {                                                                      // 1443
    var setting = Settings.findOne({ _id: "ldapDnPattern" });                                                          // 1444
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1445
  },                                                                                                                   // 1446
                                                                                                                       //
  getLdapSearchUsername: function getLdapSearchUsername() {                                                            // 1448
    var setting = Settings.findOne({ _id: "ldapSearchUsername" });                                                     // 1449
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1450
  },                                                                                                                   // 1451
                                                                                                                       //
  getLdapNameField: function getLdapNameField() {                                                                      // 1453
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 1454
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1455
  },                                                                                                                   // 1456
                                                                                                                       //
  getLdapEmailField: function getLdapEmailField() {                                                                    // 1458
    var setting = Settings.findOne({ _id: "ldapEmailField" });                                                         // 1459
    return setting ? setting.value : "mail";                                                                           // 1460
    // default to "mail". This setting was added later, and so could potentially be unset.                             //
  },                                                                                                                   // 1462
                                                                                                                       //
  getLdapExplicitDnSelected: function getLdapExplicitDnSelected() {                                                    // 1464
    var setting = Settings.findOne({ _id: "ldapExplicitDnSelected" });                                                 // 1465
    return setting && setting.value;                                                                                   // 1466
  },                                                                                                                   // 1467
                                                                                                                       //
  getLdapFilter: function getLdapFilter() {                                                                            // 1469
    var setting = Settings.findOne({ _id: "ldapFilter" });                                                             // 1470
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1471
  },                                                                                                                   // 1472
                                                                                                                       //
  getLdapSearchBindDn: function getLdapSearchBindDn() {                                                                // 1474
    var setting = Settings.findOne({ _id: "ldapSearchBindDn" });                                                       // 1475
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1476
  },                                                                                                                   // 1477
                                                                                                                       //
  getLdapSearchBindPassword: function getLdapSearchBindPassword() {                                                    // 1479
    var setting = Settings.findOne({ _id: "ldapSearchBindPassword" });                                                 // 1480
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1481
  },                                                                                                                   // 1482
                                                                                                                       //
  getOrganizationMembership: function getOrganizationMembership() {                                                    // 1484
    var setting = Settings.findOne({ _id: "organizationMembership" });                                                 // 1485
    return setting && setting.value;                                                                                   // 1486
  },                                                                                                                   // 1487
                                                                                                                       //
  getOrganizationEmailEnabled: function getOrganizationEmailEnabled() {                                                // 1489
    var membership = this.getOrganizationMembership();                                                                 // 1490
    return membership && membership.emailToken && membership.emailToken.enabled;                                       // 1491
  },                                                                                                                   // 1492
                                                                                                                       //
  getOrganizationEmailDomain: function getOrganizationEmailDomain() {                                                  // 1494
    var membership = this.getOrganizationMembership();                                                                 // 1495
    return membership && membership.emailToken && membership.emailToken.domain;                                        // 1496
  },                                                                                                                   // 1497
                                                                                                                       //
  getOrganizationGoogleEnabled: function getOrganizationGoogleEnabled() {                                              // 1499
    var membership = this.getOrganizationMembership();                                                                 // 1500
    return membership && membership.google && membership.google.enabled;                                               // 1501
  },                                                                                                                   // 1502
                                                                                                                       //
  getOrganizationGoogleDomain: function getOrganizationGoogleDomain() {                                                // 1504
    var membership = this.getOrganizationMembership();                                                                 // 1505
    return membership && membership.google && membership.google.domain;                                                // 1506
  },                                                                                                                   // 1507
                                                                                                                       //
  getOrganizationLdapEnabled: function getOrganizationLdapEnabled() {                                                  // 1509
    var membership = this.getOrganizationMembership();                                                                 // 1510
    return membership && membership.ldap && membership.ldap.enabled;                                                   // 1511
  },                                                                                                                   // 1512
                                                                                                                       //
  getOrganizationSamlEnabled: function getOrganizationSamlEnabled() {                                                  // 1514
    var membership = this.getOrganizationMembership();                                                                 // 1515
    return membership && membership.saml && membership.saml.enabled;                                                   // 1516
  },                                                                                                                   // 1517
                                                                                                                       //
  getOrganizationDisallowGuests: function getOrganizationDisallowGuests() {                                            // 1519
    return this.getOrganizationDisallowGuestsRaw() && this.isFeatureKeyValid();                                        // 1520
  },                                                                                                                   // 1521
                                                                                                                       //
  getOrganizationDisallowGuestsRaw: function getOrganizationDisallowGuestsRaw() {                                      // 1523
    var setting = Settings.findOne({ _id: "organizationSettings" });                                                   // 1524
    return setting && setting.value && setting.value.disallowGuests;                                                   // 1525
  },                                                                                                                   // 1526
                                                                                                                       //
  getOrganizationShareContacts: function getOrganizationShareContacts() {                                              // 1528
    return this.getOrganizationShareContactsRaw() && this.isFeatureKeyValid();                                         // 1529
  },                                                                                                                   // 1530
                                                                                                                       //
  getOrganizationShareContactsRaw: function getOrganizationShareContactsRaw() {                                        // 1532
    var setting = Settings.findOne({ _id: "organizationSettings" });                                                   // 1533
    if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                     // 1534
      // default to true if undefined                                                                                  //
      return true;                                                                                                     // 1536
    } else {                                                                                                           // 1537
      return setting.value.shareContacts;                                                                              // 1538
    }                                                                                                                  // 1539
  },                                                                                                                   // 1540
                                                                                                                       //
  getSamlEntryPoint: function getSamlEntryPoint() {                                                                    // 1542
    var setting = Settings.findOne({ _id: "samlEntryPoint" });                                                         // 1543
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1544
  },                                                                                                                   // 1545
                                                                                                                       //
  getSamlPublicCert: function getSamlPublicCert() {                                                                    // 1547
    var setting = Settings.findOne({ _id: "samlPublicCert" });                                                         // 1548
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1549
  },                                                                                                                   // 1550
                                                                                                                       //
  getSamlEntityId: function getSamlEntityId() {                                                                        // 1552
    var setting = Settings.findOne({ _id: "samlEntityId" });                                                           // 1553
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1554
  },                                                                                                                   // 1555
                                                                                                                       //
  getActivitySubscriptions: function getActivitySubscriptions(grainId, threadPath) {                                   // 1557
    return ActivitySubscriptions.find({                                                                                // 1558
      grainId: grainId,                                                                                                // 1559
      threadPath: threadPath || { $exists: false }                                                                     // 1560
    }, {                                                                                                               // 1558
      fields: { identityId: 1, mute: 1, _id: 0 }                                                                       // 1562
    }).fetch();                                                                                                        // 1561
  },                                                                                                                   // 1564
                                                                                                                       //
  subscribeToActivity: function subscribeToActivity(identityId, grainId, threadPath) {                                 // 1566
    // Subscribe the given identity to activity events with the given grainId and (optional)                           //
    // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                        //
    // case do nothing.                                                                                                //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1571
    if (threadPath) {                                                                                                  // 1572
      record.threadPath = threadPath;                                                                                  // 1573
    }                                                                                                                  // 1574
                                                                                                                       //
    // The $set here is redundant since an upsert automatically initializes a new record to contain                    //
    // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                      //
    // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                    //
    // What a wonderful query language.                                                                                //
    ActivitySubscriptions.upsert(record, { $set: record });                                                            // 1580
  },                                                                                                                   // 1581
                                                                                                                       //
  muteActivity: function muteActivity(identityId, grainId, threadPath) {                                               // 1583
    // Mute notifications for the given identity originating from the given grainId and                                //
    // (optional) threadPath.                                                                                          //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1587
    if (threadPath) {                                                                                                  // 1588
      record.threadPath = threadPath;                                                                                  // 1589
    }                                                                                                                  // 1590
                                                                                                                       //
    ActivitySubscriptions.upsert(record, { $set: { mute: true } });                                                    // 1592
  },                                                                                                                   // 1593
                                                                                                                       //
  updateAppIndex: function updateAppIndex() {                                                                          // 1595
    var _this2 = this;                                                                                                 // 1595
                                                                                                                       //
    var appUpdatesEnabledSetting = this.collections.settings.findOne({ _id: "appUpdatesEnabled" });                    // 1596
    var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                                // 1597
    if (!appUpdatesEnabled) {                                                                                          // 1598
      // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                       //
      // timer that triggers this call.                                                                                //
      return;                                                                                                          // 1601
    }                                                                                                                  // 1602
                                                                                                                       //
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1604
    var appIndex = this.collections.appIndex;                                                                          // 1605
    var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                        // 1606
    var preinstalledAppIds = this.getAllPreinstalledAppIds();                                                          // 1607
    // We make sure to get all preinstalled appIds, even ones that are currently                                       //
    // downloading/failed.                                                                                             //
    data.apps.forEach(function (app) {                                                                                 // 1610
      app._id = app.appId;                                                                                             // 1611
                                                                                                                       //
      var oldApp = appIndex.findOne({ _id: app.appId });                                                               // 1613
      app.hasSentNotifications = false;                                                                                // 1614
      appIndex.upsert({ _id: app._id }, app);                                                                          // 1615
      var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                               // 1616
      if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this2.collections.userActions.findOne({ appId: app.appId }) || isAppPreinstalled)) {
        var pack = _this2.collections.packages.findOne({ _id: app.packageId });                                        // 1620
        var url = appIndexUrl + "/packages/" + app.packageId;                                                          // 1621
        if (pack) {                                                                                                    // 1622
          if (pack.status === "ready") {                                                                               // 1623
            if (pack.appId && pack.appId !== app.appId) {                                                              // 1624
              console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));        // 1625
            } else {                                                                                                   // 1627
              _this2.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);   // 1628
            }                                                                                                          // 1630
          } else {                                                                                                     // 1631
            var result = Packages.findAndModify({                                                                      // 1632
              query: { _id: app.packageId },                                                                           // 1633
              update: { $set: { isAutoUpdated: true } }                                                                // 1634
            });                                                                                                        // 1632
                                                                                                                       //
            if (!result.ok) {                                                                                          // 1637
              return;                                                                                                  // 1638
            }                                                                                                          // 1639
                                                                                                                       //
            var newPack = result.value;                                                                                // 1641
            if (newPack.status === "ready") {                                                                          // 1642
              // The package was marked as ready before we applied isAutoUpdated=true. We should send                  //
              // notifications ourselves to be sure there's no timing issue (sending more than one is                  //
              // fine, since it will de-dupe).                                                                         //
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1646
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1647
              } else {                                                                                                 // 1649
                _this2.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
              }                                                                                                        // 1652
            } else if (newPack.status === "failed") {                                                                  // 1653
              // If the package has failed, retry it                                                                   //
              _this2.startInstall(app.packageId, url, true, true);                                                     // 1655
            }                                                                                                          // 1656
          }                                                                                                            // 1657
        } else {                                                                                                       // 1658
          _this2.startInstall(app.packageId, url, false, true);                                                        // 1659
        }                                                                                                              // 1660
      }                                                                                                                // 1661
    });                                                                                                                // 1662
  },                                                                                                                   // 1663
                                                                                                                       //
  isPackagePreinstalled: function isPackagePreinstalled(packageId) {                                                   // 1665
    return Settings.find({ _id: "preinstalledApps", "value.packageId": packageId }).count() === 1;                     // 1666
  },                                                                                                                   // 1667
                                                                                                                       //
  getAppIdForPreinstalledPackage: function getAppIdForPreinstalledPackage(packageId) {                                 // 1669
    var setting = Settings.findOne({ _id: "preinstalledApps", "value.packageId": packageId }, { fields: { "value.$": 1 } });
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].appId;                                     // 1674
  },                                                                                                                   // 1675
                                                                                                                       //
  getPackageIdForPreinstalledApp: function getPackageIdForPreinstalledApp(appId) {                                     // 1677
    var setting = Settings.findOne({ _id: "preinstalledApps", "value.appId": appId }, { fields: { "value.$": 1 } });   // 1678
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].packageId;                                 // 1682
  },                                                                                                                   // 1683
                                                                                                                       //
  getReadyPreinstalledAppIds: function getReadyPreinstalledAppIds() {                                                  // 1685
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1686
    var ret = setting && setting.value || [];                                                                          // 1687
    return _.chain(ret).filter(function (app) {                                                                        // 1688
      return app.status === "ready";                                                                                   // 1689
    }).map(function (app) {                                                                                            // 1689
      return app.appId;                                                                                                // 1690
    }).value();                                                                                                        // 1690
  },                                                                                                                   // 1692
                                                                                                                       //
  getAllPreinstalledAppIds: function getAllPreinstalledAppIds() {                                                      // 1694
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1695
    var ret = setting && setting.value || [];                                                                          // 1696
    return _.map(ret, function (app) {                                                                                 // 1697
      return app.appId;                                                                                                // 1697
    });                                                                                                                // 1697
  },                                                                                                                   // 1698
                                                                                                                       //
  preinstallAppsForUser: function preinstallAppsForUser(userId) {                                                      // 1700
    var _this3 = this;                                                                                                 // 1700
                                                                                                                       //
    var appIds = this.getReadyPreinstalledAppIds();                                                                    // 1701
    appIds.forEach(function (appId) {                                                                                  // 1702
      try {                                                                                                            // 1703
        _this3.addUserActions(userId, _this3.getPackageIdForPreinstalledApp(appId));                                   // 1704
      } catch (e) {                                                                                                    // 1705
        console.error("failed to install app for user:", e);                                                           // 1706
      }                                                                                                                // 1707
    });                                                                                                                // 1708
  },                                                                                                                   // 1709
                                                                                                                       //
  setPreinstallAppAsDownloading: function setPreinstallAppAsDownloading(appId, packageId) {                            // 1711
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId, "value.packageId": packageId }, { $set: { "value.$.status": "downloading" } });
  },                                                                                                                   // 1715
                                                                                                                       //
  setPreinstallAppAsReady: function setPreinstallAppAsReady(appId, packageId) {                                        // 1717
    // This function both sets the appId as ready and updates the packageId for the given appId                        //
    // Setting the packageId is especially useful in installer.js, as it always ensures the                            //
    // latest installed package will be set as ready.                                                                  //
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId }, { $set: { "value.$.status": "ready", "value.$.packageId": packageId } });
  },                                                                                                                   // 1724
                                                                                                                       //
  ensureAppPreinstall: function ensureAppPreinstall(appId, packageId) {                                                // 1726
    check(appId, String);                                                                                              // 1727
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1728
    var pack = this.collections.packages.findOne({ _id: packageId });                                                  // 1729
    var url = appIndexUrl + "/packages/" + packageId;                                                                  // 1730
    if (pack && pack.status === "ready") {                                                                             // 1731
      this.setPreinstallAppAsReady(appId, packageId);                                                                  // 1732
    } else if (pack && pack.status === "failed") {                                                                     // 1733
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1734
      this.startInstall(packageId, url, true, false);                                                                  // 1735
    } else {                                                                                                           // 1736
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1737
      this.startInstall(packageId, url, false, false);                                                                 // 1738
    }                                                                                                                  // 1739
  },                                                                                                                   // 1740
                                                                                                                       //
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 1742
    var _this4 = this;                                                                                                 // 1742
                                                                                                                       //
    // appAndPackageIds: A List[Object] where each element has fields:                                                 //
    //     appId: The Packages.appId of the app to install                                                             //
    //     packageId: The Packages._id of the app to install                                                           //
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 1746
                                                                                                                       //
    // Start by clearing out the setting. We'll push appIds one by one to it                                           //
    this.collections.settings.upsert({ _id: "preinstalledApps" }, { $set: {                                            // 1749
        value: appAndPackageIds.map(function (data) {                                                                  // 1750
          return {                                                                                                     // 1751
            appId: data.appId,                                                                                         // 1752
            status: "notReady",                                                                                        // 1753
            packageId: data.packageId                                                                                  // 1754
          };                                                                                                           // 1751
        })                                                                                                             // 1756
      } });                                                                                                            // 1749
    appAndPackageIds.forEach(function (data) {                                                                         // 1758
      _this4.ensureAppPreinstall(data.appId, data.packageId);                                                          // 1759
    });                                                                                                                // 1760
  },                                                                                                                   // 1761
                                                                                                                       //
  getProductivitySuiteAppIds: function getProductivitySuiteAppIds() {                                                  // 1763
    return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                          // 1764
    "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                                // 1766
    "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                             // 1767
    "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                           // 1768
  },                                                                                                                   // 1770
                                                                                                                       //
  // Wekan                                                                                                             //
  getSystemSuiteAppIds: function getSystemSuiteAppIds() {                                                              // 1772
    return ["s3u2xgmqwznz2n3apf30sm3gw1d85y029enw5pymx734cnk5n78h"];                                                   // 1773
  },                                                                                                                   // 1776
                                                                                                                       //
  // Collections                                                                                                       //
  isPreinstalledAppsReady: function isPreinstalledAppsReady() {                                                        // 1778
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1779
    if (!setting || !setting.value) {                                                                                  // 1780
      return true;                                                                                                     // 1781
    }                                                                                                                  // 1782
                                                                                                                       //
    var packageIds = _.pluck(setting.value, "packageId");                                                              // 1784
    var readyApps = this.collections.packages.find({                                                                   // 1785
      _id: {                                                                                                           // 1786
        $in: packageIds                                                                                                // 1787
      },                                                                                                               // 1786
      status: "ready"                                                                                                  // 1789
    });                                                                                                                // 1785
    return readyApps.count() === packageIds.length;                                                                    // 1791
  },                                                                                                                   // 1792
                                                                                                                       //
  getBillingPromptUrl: function getBillingPromptUrl() {                                                                // 1794
    var setting = this.collections.settings.findOne({ _id: "billingPromptUrl" });                                      // 1795
    return setting && setting.value;                                                                                   // 1796
  },                                                                                                                   // 1797
                                                                                                                       //
  isReferralEnabled: function isReferralEnabled() {                                                                    // 1799
    // This function is a bit weird, in that we've transitioned from                                                   //
    // Meteor.settings.public.quotaEnabled to DB settings. For now,                                                    //
    // Meteor.settings.public.quotaEnabled implies bothisReferralEnabled and isQuotaEnabled are true.                  //
    return Meteor.settings["public"].quotaEnabled;                                                                     // 1803
  },                                                                                                                   // 1804
                                                                                                                       //
  isQuotaEnabled: function isQuotaEnabled() {                                                                          // 1806
    if (Meteor.settings["public"].quotaEnabled) return true;                                                           // 1807
                                                                                                                       //
    var setting = this.collections.settings.findOne({ _id: "quotaEnabled" });                                          // 1809
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1810
  },                                                                                                                   // 1811
                                                                                                                       //
  isQuotaLdapEnabled: function isQuotaLdapEnabled() {                                                                  // 1813
    var setting = this.collections.settings.findOne({ _id: "quotaLdapEnabled" });                                      // 1814
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1815
  },                                                                                                                   // 1816
                                                                                                                       //
  updateUserQuota: function updateUserQuota(user) {                                                                    // 1818
    if (this.quotaManager) {                                                                                           // 1819
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1820
    }                                                                                                                  // 1821
  },                                                                                                                   // 1822
                                                                                                                       //
  getUserQuota: function getUserQuota(user) {                                                                          // 1824
    if (this.isQuotaLdapEnabled()) {                                                                                   // 1825
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1826
    } else {                                                                                                           // 1827
      var plan = Plans.findOne(user.plan || "free");                                                                   // 1828
      var referralBonus = calculateReferralBonus(user);                                                                // 1829
      var bonus = user.planBonus || {};                                                                                // 1830
      var userQuota = {                                                                                                // 1831
        storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                          // 1832
        grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                              // 1833
        compute: plan.compute + (bonus.compute || 0)                                                                   // 1834
      };                                                                                                               // 1831
      return userQuota;                                                                                                // 1836
    }                                                                                                                  // 1837
  },                                                                                                                   // 1838
                                                                                                                       //
  isUserOverQuota: function isUserOverQuota(user) {                                                                    // 1840
    // Return false if user has quota space remaining, true if it is full. When this returns true,                     //
    // we will not allow the user to create new grains, though they may be able to open existing ones                  //
    // which may still increase their storage usage.                                                                   //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1847
                                                                                                                       //
    var plan = this.getUserQuota(user);                                                                                // 1849
    if (plan.grains < Infinity) {                                                                                      // 1850
      var count = this.collections.grains.find({ userId: user._id }, { fields: {}, limit: plan.grains }).count();      // 1851
      if (count >= plan.grains) return "outOfGrains";                                                                  // 1853
    }                                                                                                                  // 1854
                                                                                                                       //
    return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                           // 1856
  },                                                                                                                   // 1857
                                                                                                                       //
  isUserExcessivelyOverQuota: function isUserExcessivelyOverQuota(user) {                                              // 1859
    // Return true if user is so far over quota that we should prevent their existing grains from                      //
    // running at all.                                                                                                 //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1865
                                                                                                                       //
    var quota = this.getUserQuota(user);                                                                               // 1867
                                                                                                                       //
    // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                           //
    if (quota.grains < Infinity) {                                                                                     // 1870
      var count = this.collections.grains.find({ userId: user._id }, { fields: {}, limit: quota.grains * 2 }).count();
      if (count >= quota.grains * 2) return "outOfGrains";                                                             // 1873
    }                                                                                                                  // 1874
                                                                                                                       //
    return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                   // 1876
  }                                                                                                                    // 1877
});                                                                                                                    // 1134
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 1880
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     //
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   //
  // and seems to be a de facto standard, for example:                                                                 //
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  //
  return key.replace(".", "．").replace("$", "＄");                                                                      // 1885
};                                                                                                                     // 1886
                                                                                                                       //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                     // 1888
  // This function takes a Package object from Mongo and returns an                                                    //
  // app title.                                                                                                        //
  var manifest = packageObj.manifest;                                                                                  // 1891
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 1892
  var action = manifest.actions[0];                                                                                    // 1893
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 1894
  return appName;                                                                                                      // 1896
};                                                                                                                     // 1897
                                                                                                                       //
var appNameFromActionName = function appNameFromActionName(name) {                                                     // 1899
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               //
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  //
  //   derive the app title from the action title.                                                                     //
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        //
  if (!name) {                                                                                                         // 1904
    return "(unnamed)";                                                                                                // 1905
  }                                                                                                                    // 1906
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 1908
    name = name.slice(4);                                                                                              // 1909
  }                                                                                                                    // 1910
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 1912
    name = "Hacker CMS";                                                                                               // 1913
  } else {                                                                                                             // 1914
    var space = name.indexOf(" ");                                                                                     // 1915
    if (space > 0) {                                                                                                   // 1916
      name = name.slice(0, space);                                                                                     // 1917
    }                                                                                                                  // 1918
  }                                                                                                                    // 1919
                                                                                                                       //
  return name;                                                                                                         // 1921
};                                                                                                                     // 1922
                                                                                                                       //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                    // 1924
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 1928
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                       // 1930
  // A hack to deal with legacy apps not including fields in their manifests.                                          //
  // I look forward to the day I can remove most of this code.                                                         //
  // Attempt to figure out the appropriate noun that this action will create.                                          //
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            //
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                         // 1935
  // Otherwise, try to guess one from the structure of the action title field                                          //
  if (action.title && action.title.defaultText) {                                                                      // 1937
    var text = action.title.defaultText;                                                                               // 1938
    // Strip a leading "New "                                                                                          //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 1940
      var candidate = text.slice(4);                                                                                   // 1941
      // Strip a leading appname too, if provided                                                                      //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 1943
        var newCandidate = candidate.slice(appTitle.length);                                                           // 1944
        // Unless that leaves you with no noun, in which case, use "grain"                                             //
        if (newCandidate.length > 0) {                                                                                 // 1946
          return newCandidate.toLowerCase();                                                                           // 1947
        } else {                                                                                                       // 1948
          return "grain";                                                                                              // 1949
        }                                                                                                              // 1950
      }                                                                                                                // 1951
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 1953
    }                                                                                                                  // 1954
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                        //
    // the package soon.                                                                                               //
    return text;                                                                                                       // 1957
  } else {                                                                                                             // 1958
    return "grain";                                                                                                    // 1959
  }                                                                                                                    // 1960
};                                                                                                                     // 1961
                                                                                                                       //
// Static methods on SandstormDb that don't need an instance.                                                          //
// Largely things that deal with backwards-compatibility.                                                              //
_.extend(SandstormDb, {                                                                                                // 1965
  appNameFromActionName: appNameFromActionName,                                                                        // 1966
  appNameFromPackage: appNameFromPackage,                                                                              // 1967
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 1968
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 1969
});                                                                                                                    // 1965
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1972
  (function () {                                                                                                       // 1972
    var cleanupExpiredAssetUploads = function cleanupExpiredAssetUploads() {                                           // 1972
      AssetUploadTokens.remove({ expires: { $lt: Date.now() } });                                                      // 2197
    };                                                                                                                 // 2198
                                                                                                                       //
    // Cleanup tokens every hour.                                                                                      //
                                                                                                                       //
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1973
    var ContentType = Npm.require("content-type");                                                                     // 1974
    var Zlib = Npm.require("zlib");                                                                                    // 1975
    var Url = Npm.require("url");                                                                                      // 1976
                                                                                                                       //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                            // 1978
                                                                                                                       //
    var computeStagger = function computeStagger(n) {                                                                  // 1980
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                        //
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                         //
      // The sequence looks like:                                                                                      //
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                             //
      //                                                                                                               //
      // We use this to determine how we'll stagger periodic events performed by this replica.                         //
      // Notice that this allows us to compute a stagger which is independent of the number of                         //
      // front-end replicas present; we can add more replicas to the end without affecting how the                     //
      // earlier ones schedule their events.                                                                           //
      var denom = 1;                                                                                                   // 1990
      while (denom <= n) {                                                                                             // 1991
        denom <<= 1;                                                                                                   // 1991
      }var num = n * 2 - denom + 1;                                                                                    // 1991
      return num / denom;                                                                                              // 1993
    };                                                                                                                 // 1994
                                                                                                                       //
    var stagger = computeStagger(replicaNumber);                                                                       // 1996
                                                                                                                       //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                    // 1998
      // Register a database cleanup function than should run periodically, roughly once every                         //
      // interval of the given length.                                                                                 //
      //                                                                                                               //
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                      //
      // scaled appropriately on the assumption that more data is being generated demanding more                       //
      // frequent cleanups.                                                                                            //
                                                                                                                       //
      check(intervalMs, Number);                                                                                       // 2006
      check(callback, Function);                                                                                       // 2007
                                                                                                                       //
      if (intervalMs < 120000) {                                                                                       // 2009
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");    // 2010
      }                                                                                                                // 2012
                                                                                                                       //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      //
      // the schedule is independent of the exact startup time.                                                        //
      var first = intervalMs - Date.now() % intervalMs;                                                                // 2016
                                                                                                                       //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                       //
      // same data at the same time.                                                                                   //
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                 // 2020
                                                                                                                       //
      // If the stagger put us more than an interval away from now, back up.                                           //
      if (first > intervalMs) first -= intervalMs;                                                                     // 2023
                                                                                                                       //
      Meteor.setTimeout(function () {                                                                                  // 2025
        callback();                                                                                                    // 2026
        Meteor.setInterval(callback, intervalMs);                                                                      // 2027
      }, first);                                                                                                       // 2028
    };                                                                                                                 // 2029
                                                                                                                       //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                          //
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                  // 2032
                                                                                                                       //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                        // 2034
      return Match.Where(function (buf) {                                                                              // 2035
        check(buf, Buffer);                                                                                            // 2036
        return buf.length < limit;                                                                                     // 2037
      });                                                                                                              // 2038
    };                                                                                                                 // 2039
                                                                                                                       //
    var DatabaseId = Match.Where(function (s) {                                                                        // 2041
      check(s, String);                                                                                                // 2042
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                             // 2043
    });                                                                                                                // 2044
                                                                                                                       //
    addStaticAsset = function addStaticAsset(metadata, content) {                                                      // 2046
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                     //
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                  //
                                                                                                                       //
      if (typeof content === "string" && !metadata.encoding) {                                                         // 2050
        content = gzipSync(new Buffer(content, "utf8"));                                                               // 2051
        metadata.encoding = "gzip";                                                                                    // 2052
      }                                                                                                                // 2053
                                                                                                                       //
      check(metadata, {                                                                                                // 2055
        mimeType: String,                                                                                              // 2056
        encoding: Match.Optional("gzip")                                                                               // 2057
      });                                                                                                              // 2055
      check(content, BufferSmallerThan(1 << 20));                                                                      // 2059
                                                                                                                       //
      // Validate content type.                                                                                        //
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                    // 2062
                                                                                                                       //
      var hasher = Crypto.createHash("sha256");                                                                        // 2064
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                      // 2065
      hasher.update(content);                                                                                          // 2066
      var hash = hasher.digest("base64");                                                                              // 2067
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2069
        query: { hash: hash, refcount: { $gte: 1 } },                                                                  // 2070
        update: { $inc: { refcount: 1 } },                                                                             // 2071
        fields: { _id: 1, refcount: 1 }                                                                                // 2072
      });                                                                                                              // 2069
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2075
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2076
      }                                                                                                                // 2077
                                                                                                                       //
      var existing = result.value;                                                                                     // 2079
      if (existing) {                                                                                                  // 2080
        return existing._id;                                                                                           // 2081
      }                                                                                                                // 2082
                                                                                                                       //
      return StaticAssets.insert(_.extend({                                                                            // 2084
        hash: hash,                                                                                                    // 2085
        content: content,                                                                                              // 2086
        refcount: 1                                                                                                    // 2087
      }, metadata));                                                                                                   // 2084
    };                                                                                                                 // 2089
                                                                                                                       //
    SandstormDb.prototype.addStaticAsset = addStaticAsset;                                                             // 2091
                                                                                                                       //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                             // 2093
      // Increment the refcount on an existing static asset. Returns the asset on success.                             //
      // If the asset does not exist, returns a falsey value.                                                          //
      //                                                                                                               //
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                      //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2101
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2103
        query: { hash: hash },                                                                                         // 2104
        update: { $inc: { refcount: 1 } },                                                                             // 2105
        fields: { _id: 1, content: 1, mimeType: 1 }                                                                    // 2106
      });                                                                                                              // 2103
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2109
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2110
      }                                                                                                                // 2111
                                                                                                                       //
      var existing = result.value;                                                                                     // 2113
      return existing;                                                                                                 // 2114
    };                                                                                                                 // 2115
                                                                                                                       //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                           // 2117
      // Decrement refcount on a static asset and delete if it has reached zero.                                       //
      //                                                                                                               //
      // You must call this AFTER removing the reference from the DB, in case of failure between                       //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2124
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2126
        query: { _id: id },                                                                                            // 2127
        update: { $inc: { refcount: -1 } },                                                                            // 2128
        fields: { _id: 1, refcount: 1 },                                                                               // 2129
        "new": true                                                                                                    // 2130
      });                                                                                                              // 2126
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2133
        throw new Error("Couldn't unref static asset " + id);                                                          // 2134
      }                                                                                                                // 2135
                                                                                                                       //
      var existing = result.value;                                                                                     // 2137
      if (!existing) {                                                                                                 // 2138
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                       // 2139
      } else if (existing.refcount <= 0) {                                                                             // 2140
        StaticAssets.remove({ _id: existing._id });                                                                    // 2141
      }                                                                                                                // 2142
    };                                                                                                                 // 2143
                                                                                                                       //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                             // 2145
      // Get a static asset's mimeType, encoding, and raw content.                                                     //
                                                                                                                       //
      check(id, String);                                                                                               // 2148
                                                                                                                       //
      var asset = StaticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });              // 2150
      if (asset) {                                                                                                     // 2151
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                      //
        //   here.                                                                                                     //
        asset.content = new Buffer(asset.content);                                                                     // 2154
      }                                                                                                                // 2155
                                                                                                                       //
      return asset;                                                                                                    // 2157
    };                                                                                                                 // 2158
                                                                                                                       //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                        // 2160
      check(purpose, Match.OneOf({ profilePicture: { userId: DatabaseId, identityId: DatabaseId } }, { loginLogo: {} }));
                                                                                                                       //
      return AssetUploadTokens.insert({                                                                                // 2166
        purpose: purpose,                                                                                              // 2167
        expires: new Date(Date.now() + 300000) });                                                                     // 2168
    };                                                                                                                 // 2170
                                                                                                                       //
    // in 5 minutes                                                                                                    //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                         // 2172
      // Indicates that the given asset upload has completed. It will be removed and its purpose                       //
      // returned. If no matching upload exists, returns undefined.                                                    //
                                                                                                                       //
      check(id, String);                                                                                               // 2176
                                                                                                                       //
      var result = AssetUploadTokens.findAndModify({                                                                   // 2178
        query: { _id: id },                                                                                            // 2179
        remove: true                                                                                                   // 2180
      });                                                                                                              // 2178
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2183
        throw new Error("Failed to remove asset upload token");                                                        // 2184
      }                                                                                                                // 2185
                                                                                                                       //
      var upload = result.value;                                                                                       // 2187
                                                                                                                       //
      if (upload.expires.valueOf() < Date.now()) {                                                                     // 2189
        return undefined; // already expired                                                                           // 2190
      } else {                                                                                                         // 2191
          return upload.purpose;                                                                                       // 2192
        }                                                                                                              // 2193
    };                                                                                                                 // 2194
                                                                                                                       //
    SandstormDb.periodicCleanup(3600000, cleanupExpiredAssetUploads);                                                  // 2201
                                                                                                                       //
    SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                             // 2203
      var _this5 = this;                                                                                               // 2203
                                                                                                                       //
      // Returns the number of grains deleted.                                                                         //
                                                                                                                       //
      check(type, Match.OneOf("grain", "demoGrain"));                                                                  // 2206
                                                                                                                       //
      var numDeleted = 0;                                                                                              // 2208
      Grains.find(query).forEach(function (grain) {                                                                    // 2209
        waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                     // 2210
        numDeleted += Grains.remove({ _id: grain._id });                                                               // 2211
        _this5.removeApiTokens({                                                                                       // 2212
          grainId: grain._id,                                                                                          // 2213
          $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                            // 2214
        });                                                                                                            // 2212
                                                                                                                       //
        _this5.removeApiTokens({ "owner.grain.grainId": grain._id });                                                  // 2220
                                                                                                                       //
        ActivitySubscriptions.remove({ grainId: grain._id });                                                          // 2222
                                                                                                                       //
        if (grain.lastUsed) {                                                                                          // 2224
          DeleteStats.insert({                                                                                         // 2225
            type: "grain", // Demo grains can never get here!                                                          // 2226
            lastActive: grain.lastUsed,                                                                                // 2227
            appId: grain.appId                                                                                         // 2228
          });                                                                                                          // 2225
        }                                                                                                              // 2230
                                                                                                                       //
        _this5.deleteUnusedPackages(grain.appId);                                                                      // 2232
                                                                                                                       //
        if (grain.size) {                                                                                              // 2234
          Meteor.users.update(grain.userId, { $inc: { storageUsage: -grain.size } });                                  // 2235
        }                                                                                                              // 2236
      });                                                                                                              // 2237
      return numDeleted;                                                                                               // 2238
    };                                                                                                                 // 2239
                                                                                                                       //
    SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                 // 2241
      check(grainId, String);                                                                                          // 2242
      check(accountId, Match.OneOf(String, undefined, null));                                                          // 2243
      check(identityId, String);                                                                                       // 2244
                                                                                                                       //
      var grain = this.getGrain(grainId);                                                                              // 2246
      if (!grain) {                                                                                                    // 2247
        throw new Error("called userGrainTitle() for a grain that doesn't exist");                                     // 2248
      }                                                                                                                // 2249
                                                                                                                       //
      var title = grain.title;                                                                                         // 2251
      if (grain.userId !== accountId) {                                                                                // 2252
        var sharerToken = this.collections.apiTokens.findOne({                                                         // 2253
          grainId: grainId,                                                                                            // 2254
          "owner.user.identityId": identityId                                                                          // 2255
        }, {                                                                                                           // 2253
          sort: {                                                                                                      // 2257
            lastUsed: -1                                                                                               // 2258
          }                                                                                                            // 2257
        });                                                                                                            // 2256
        if (sharerToken) {                                                                                             // 2261
          title = sharerToken.owner.user.title;                                                                        // 2262
        } else {                                                                                                       // 2263
          title = "shared grain";                                                                                      // 2264
        }                                                                                                              // 2265
      }                                                                                                                // 2266
                                                                                                                       //
      return title;                                                                                                    // 2268
    };                                                                                                                 // 2269
                                                                                                                       //
    var packageCache = {};                                                                                             // 2271
    // Package info is immutable. Let's cache to save on mongo queries.                                                //
                                                                                                                       //
    SandstormDb.prototype.getPackage = function (packageId) {                                                          // 2274
      // Get the given package record. Since package info is immutable, cache the data in the server                   //
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                       //
      // lot.                                                                                                          //
                                                                                                                       //
      if (packageId in packageCache) {                                                                                 // 2279
        return packageCache[packageId];                                                                                // 2280
      }                                                                                                                // 2281
                                                                                                                       //
      var pkg = Packages.findOne(packageId);                                                                           // 2283
      if (pkg && pkg.status === "ready") {                                                                             // 2284
        packageCache[packageId] = pkg;                                                                                 // 2285
      }                                                                                                                // 2286
                                                                                                                       //
      return pkg;                                                                                                      // 2288
    };                                                                                                                 // 2289
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                    // 2291
      check(appId, String);                                                                                            // 2292
      Packages.find({ appId: appId }).forEach(function (pkg) {                                                         // 2293
        // Mark package for possible deletion;                                                                         //
        Packages.update({ _id: pkg._id, status: "ready" }, { $set: { shouldCleanup: true } });                         // 2295
      });                                                                                                              // 2296
    };                                                                                                                 // 2297
                                                                                                                       //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this = this;                                                                                                // 2301
      var actions = _this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                              // 2304
        var userId = action.userId;                                                                                    // 2305
        var updater = {                                                                                                // 2306
          timestamp: new Date(),                                                                                       // 2307
          isUnread: true                                                                                               // 2308
        };                                                                                                             // 2306
        var inserter = _.extend({ userId: userId, appUpdates: {} }, updater);                                          // 2310
                                                                                                                       //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                    //
        // field inside of an object to update                                                                         //
        inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                // 2314
          marketingVersion: marketingVersion,                                                                          // 2315
          packageId: packageId,                                                                                        // 2316
          name: name,                                                                                                  // 2317
          version: versionNumber                                                                                       // 2318
        };                                                                                                             // 2314
                                                                                                                       //
        // We unfortunately cannot upsert because upserts can only have field equality conditions in                   //
        // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                       //
        if (_this.collections.notifications.update({ userId: userId, appUpdates: { $exists: true } }, { $set: updater }) == 0) {
          // Update failed; try an insert instead.                                                                     //
          _this.collections.notifications.insert(inserter);                                                            // 2327
        }                                                                                                              // 2328
      });                                                                                                              // 2329
                                                                                                                       //
      _this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                     // 2331
                                                                                                                       //
      // In the case where we replaced a previous notification and that was the only reference to the                  //
      // package, we need to clean it up                                                                               //
      this.deleteUnusedPackages(appId);                                                                                // 2335
    };                                                                                                                 // 2336
                                                                                                                       //
    SandstormDb.prototype.sendReferralProgramNotification = sendReferralProgramNotification;                           // 2338
                                                                                                                       //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                              // 2340
      check(appId, String);                                                                                            // 2341
      check(version, Match.Integer);                                                                                   // 2342
      check(packageId, String);                                                                                        // 2343
                                                                                                                       //
      var selector = {                                                                                                 // 2345
        userId: Meteor.userId(),                                                                                       // 2346
        appId: appId,                                                                                                  // 2347
        appVersion: { $lte: version },                                                                                 // 2348
        packageId: { $ne: packageId }                                                                                  // 2349
      };                                                                                                               // 2345
                                                                                                                       //
      Grains.find(selector).forEach(function (grain) {                                                                 // 2352
        backend.shutdownGrain(grain._id, grain.userId);                                                                // 2353
      });                                                                                                              // 2354
                                                                                                                       //
      Grains.update(selector, {                                                                                        // 2356
        $set: { appVersion: version, packageId: packageId, packageSalt: Random.secret() }                              // 2357
      }, { multi: true });                                                                                             // 2356
    };                                                                                                                 // 2359
                                                                                                                       //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                       // 2361
      // Mark package for possible installation.                                                                       //
                                                                                                                       //
      var fields = {                                                                                                   // 2364
        status: "download",                                                                                            // 2365
        progress: 0,                                                                                                   // 2366
        url: url,                                                                                                      // 2367
        isAutoUpdated: !!isAutoUpdated                                                                                 // 2368
      };                                                                                                               // 2364
                                                                                                                       //
      if (retryFailed) {                                                                                               // 2371
        Packages.update({ _id: packageId, status: "failed" }, { $set: fields });                                       // 2372
      } else {                                                                                                         // 2373
        try {                                                                                                          // 2374
          fields._id = packageId;                                                                                      // 2375
          Packages.insert(fields);                                                                                     // 2376
        } catch (err) {                                                                                                // 2377
          console.error("Simultaneous startInstall()s?", err.stack);                                                   // 2378
        }                                                                                                              // 2379
      }                                                                                                                // 2380
    };                                                                                                                 // 2381
                                                                                                                       //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                  // 2383
      check(keyFingerprint, String);                                                                                   // 2384
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                 // 2385
    });                                                                                                                // 2386
                                                                                                                       //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                      // 2388
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                   //
                                                                                                                       //
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2391
                                                                                                                       //
      console.log("fetching keybase", keyFingerprint);                                                                 // 2393
                                                                                                                       //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                  // 2398
      }, function (err, keybaseResponse) {                                                                             // 2397
        if (err) {                                                                                                     // 2400
          console.log("keybase lookup error:", err.stack);                                                             // 2401
          return;                                                                                                      // 2402
        }                                                                                                              // 2403
                                                                                                                       //
        if (!keybaseResponse.data) {                                                                                   // 2405
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                // 2406
          return;                                                                                                      // 2407
        }                                                                                                              // 2408
                                                                                                                       //
        var profile = (keybaseResponse.data.them || [])[0];                                                            // 2410
                                                                                                                       //
        if (profile) {                                                                                                 // 2412
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                       //
          var record = {                                                                                               // 2414
            displayName: (profile.profile || {}).full_name,                                                            // 2415
            handle: (profile.basics || {}).username,                                                                   // 2416
            proofs: (profile.proofs_summary || {}).all || []                                                           // 2417
          };                                                                                                           // 2414
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                        //
                                                                                                                       //
          record.proofs.forEach(function (proof) {                                                                     // 2421
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                    //
            // this would filter.)                                                                                     //
            for (var field in proof) {                                                                                 // 2424
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                    //
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                        //
              // return any objects anyway).                                                                           //
              if (field.match(/[.$]/) || _typeof(proof[field]) === "object") {                                         // 2428
                delete proof[field];                                                                                   // 2429
              }                                                                                                        // 2430
            }                                                                                                          // 2431
                                                                                                                       //
            // Indicate not verified.                                                                                  //
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                    //
            //   Keybase node-based CLI.                                                                               //
            proof.status = "unverified";                                                                               // 2436
          });                                                                                                          // 2437
                                                                                                                       //
          KeybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });                                  // 2439
        } else {                                                                                                       // 2440
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                    //
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                    //
          // from Keybase.                                                                                             //
          //                                                                                                           //
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                     //
          //   but at present we don't have the ability to verify proofs.                                              //
          KeybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                              // 2449
      });                                                                                                              // 2450
    };                                                                                                                 // 2451
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                       // 2453
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                        //
                                                                                                                       //
      check(identityId, String);                                                                                       // 2456
      var account = Meteor.users.findOne({ "loginIdentities.id": identityId });                                        // 2457
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !Grains.findOne({ userId: account._id }) && !ApiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !Contacts.findOne({ ownerId: account._id })) {
        Meteor.users.remove({ _id: account._id });                                                                     // 2466
        backend.deleteUser(account._id);                                                                               // 2467
      }                                                                                                                // 2468
    };                                                                                                                 // 2469
                                                                                                                       //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                       // 2471
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2472
      var db = this.connection.sandstormDb;                                                                            // 2473
                                                                                                                       //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                // 2475
      if (cursor.count() === 0) {                                                                                      // 2476
        // Fire off async update.                                                                                      //
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                  // 2478
      }                                                                                                                // 2479
                                                                                                                       //
      return cursor;                                                                                                   // 2481
    });                                                                                                                // 2482
                                                                                                                       //
    Meteor.publish("appIndex", function (appId) {                                                                      // 2484
      check(appId, String);                                                                                            // 2485
      var db = this.connection.sandstormDb;                                                                            // 2486
      var cursor = db.collections.appIndex.find({ _id: appId });                                                       // 2487
      return cursor;                                                                                                   // 2488
    });                                                                                                                // 2489
                                                                                                                       //
    Meteor.publish("userPackages", function () {                                                                       // 2491
      var _this6 = this;                                                                                               // 2491
                                                                                                                       //
      // Users should be able to see packages that are either:                                                         //
      // 1. referenced by one of their userActions                                                                     //
      // 2. referenced by one of their grains                                                                          //
      var db = this.connection.sandstormDb;                                                                            // 2495
                                                                                                                       //
      // Note that package information, once it is in the database, is static. There's no need to                      //
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                    //
      // to reactively remove a package from the client side when it is removed on the server, or                      //
      // when the client stops using it, because the worst case is the client has a small amount                       //
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                        //
      // So, we implement this as a cache: the first time each package ID shows up among the user's                    //
      // stuff, we push the package info to the client, and then we never update it.                                   //
      //                                                                                                               //
      // Alternatively, we could subscribe to each individual package query, but this would waste                      //
      // lots of server-side resources watching for events that will never happen or don't matter.                     //
      var hasPackage = {};                                                                                             // 2507
      var refPackage = function refPackage(packageId) {                                                                // 2508
        // Ignore dev apps.                                                                                            //
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                            // 2510
                                                                                                                       //
        if (!hasPackage[packageId]) {                                                                                  // 2512
          hasPackage[packageId] = true;                                                                                // 2513
          var pkg = db.getPackage(packageId);                                                                          // 2514
          if (pkg) {                                                                                                   // 2515
            _this6.added("packages", packageId, pkg);                                                                  // 2516
          } else {                                                                                                     // 2517
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                 // 2518
          }                                                                                                            // 2520
        }                                                                                                              // 2521
      };                                                                                                               // 2522
                                                                                                                       //
      // package source 1: packages referred to by actions                                                             //
      var actions = db.userActions(this.userId);                                                                       // 2525
      var actionsHandle = actions.observe({                                                                            // 2526
        added: function added(newAction) {                                                                             // 2527
          refPackage(newAction.packageId);                                                                             // 2528
        },                                                                                                             // 2529
                                                                                                                       //
        changed: function changed(newAction, oldAction) {                                                              // 2531
          refPackage(newAction.packageId);                                                                             // 2532
        }                                                                                                              // 2533
      });                                                                                                              // 2526
                                                                                                                       //
      // package source 2: packages referred to by grains directly                                                     //
      var grains = db.userGrains(this.userId);                                                                         // 2537
      var grainsHandle = grains.observe({                                                                              // 2538
        added: function added(newGrain) {                                                                              // 2539
          refPackage(newGrain.packageId);                                                                              // 2540
        },                                                                                                             // 2541
                                                                                                                       //
        changed: function changed(newGrain, oldGrain) {                                                                // 2543
          refPackage(newGrain.packageId);                                                                              // 2544
        }                                                                                                              // 2545
      });                                                                                                              // 2538
                                                                                                                       //
      this.onStop(function () {                                                                                        // 2548
        actionsHandle.stop();                                                                                          // 2549
        grainsHandle.stop();                                                                                           // 2550
      });                                                                                                              // 2551
                                                                                                                       //
      this.ready();                                                                                                    // 2553
    });                                                                                                                // 2554
  })();                                                                                                                // 1972
}                                                                                                                      // 2555
                                                                                                                       //
var processRawFeatureKey = function processRawFeatureKey(featureKey) {                                                 // 2557
  // Maps the raw data of a signed feature key to the desired "effective" feature key we should use                    //
  // to govern high-level behavior.                                                                                    //
  var processedFeatureKey = _.clone(featureKey);                                                                       // 2560
                                                                                                                       //
  // Hook for future extensibility.                                                                                    //
  return processedFeatureKey;                                                                                          // 2563
};                                                                                                                     // 2564
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2566
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2567
    // Returns an object with all of the current signed feature key properties,                                        //
    // or undefined, if the feature key is missing or not correctly signed.                                            //
    var doc = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                       // 2570
    if (!doc) return undefined;                                                                                        // 2571
    var buf = new Buffer(doc.value);                                                                                   // 2572
    // We use loadSignedFeatureKey from server/feature-key.js.  This should probably get refactored                    //
    // once we can use ES6 modules.                                                                                    //
    var rawFeatureKey = loadSignedFeatureKey(buf);                                                                     // 2575
    return processRawFeatureKey(rawFeatureKey);                                                                        // 2576
  };                                                                                                                   // 2577
} else {                                                                                                               // 2578
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2579
    var featureKey = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                // 2580
    return processRawFeatureKey(featureKey);                                                                           // 2581
  };                                                                                                                   // 2582
}                                                                                                                      // 2583
                                                                                                                       //
Meteor.methods({                                                                                                       // 2585
  addUserActions: function addUserActions(packageId) {                                                                 // 2586
    check(packageId, String);                                                                                          // 2587
    if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                       // 2588
      throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                         // 2589
    }                                                                                                                  // 2590
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2592
      // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                      //
      //   a proper DB object to use.                                                                                  //
      new SandstormDb().addUserActions(this.userId, packageId, true);                                                  // 2595
    } else {                                                                                                           // 2596
      this.connection.sandstormDb.addUserActions(this.userId, packageId);                                              // 2597
    }                                                                                                                  // 2598
  },                                                                                                                   // 2599
  removeUserAction: function removeUserAction(actionId) {                                                              // 2601
    check(actionId, String);                                                                                           // 2602
    if (this.isSimulation) {                                                                                           // 2603
      UserActions.remove({ _id: actionId });                                                                           // 2604
    } else {                                                                                                           // 2605
      if (this.userId) {                                                                                               // 2606
        var result = UserActions.findAndModify({                                                                       // 2607
          query: { _id: actionId, userId: this.userId },                                                               // 2608
          remove: true                                                                                                 // 2609
        });                                                                                                            // 2607
                                                                                                                       //
        if (!result.ok) {                                                                                              // 2612
          throw new Error("Couldn't remove user action " + actionId);                                                  // 2613
        }                                                                                                              // 2614
                                                                                                                       //
        var action = result.value;                                                                                     // 2616
        if (action) {                                                                                                  // 2617
          this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                              // 2618
        }                                                                                                              // 2619
      }                                                                                                                // 2620
    }                                                                                                                  // 2621
  }                                                                                                                    // 2622
});                                                                                                                    // 2585
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       //
    // has a given identity linked. Automatically stops the subscription if the user loses the                         //
    // identity. Returns a boolean indicating whether the user initially has the identity.                             //
                                                                                                                       //
    var userId = publishHandler.userId;                                                                                // 26
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var _ret = function () {                                                                                         // 29
        var hasIdentityCursor = Meteor.users.find({                                                                    // 30
          $or: [{                                                                                                      // 31
            _id: userId,                                                                                               // 33
            "loginIdentities.id": identityId                                                                           // 34
          }, {                                                                                                         // 32
            _id: userId,                                                                                               // 37
            "nonloginIdentities.id": identityId                                                                        // 38
          }]                                                                                                           // 36
        });                                                                                                            // 30
        if (hasIdentityCursor.count() == 0) {                                                                          // 42
          publishHandler.stop();                                                                                       // 43
          return {                                                                                                     // 44
            v: false                                                                                                   // 44
          };                                                                                                           // 44
        }                                                                                                              // 45
                                                                                                                       //
        var handle = hasIdentityCursor.observe({ removed: function removed() {                                         // 47
            publishHandler.stop();                                                                                     // 47
          } });                                                                                                        // 47
                                                                                                                       //
        publishHandler.onStop(function () {                                                                            // 49
          handle.stop();                                                                                               // 49
        });                                                                                                            // 49
                                                                                                                       //
        return {                                                                                                       // 51
          v: true                                                                                                      // 51
        };                                                                                                             // 51
      }();                                                                                                             // 29
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 29
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
                                                                                                                       //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                          // 59
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
                                                                                                                       //
        "services.dev.name": 1,                                                                                        // 66
                                                                                                                       //
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
                                                                                                                       //
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
                                                                                                                       //
        "services.email.email": 1,                                                                                     // 81
                                                                                                                       //
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
                                                                                                                       //
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                //
                                                                                                                       //
    if (!this.userId) return [];                                                                                       // 97
                                                                                                                       //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                         // 99
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      } });                                                                                                            // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function makeIdenticon(id) {                                                                         // 111
    var hash = id.slice(0, 32);                                                                                        // 112
    return httpProtocol + "//" + makeWildcardHost("static") + "/identicon/" + hash + "?s=256";                         // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  (function () {                                                                                                       // 118
    var identiconCache = {};                                                                                           // 119
                                                                                                                       //
    makeIdenticon = function makeIdenticon(id) {                                                                       // 121
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                          //
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                 //
                                                                                                                       //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                       //
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                   //
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                      //
      // anyway to be safe.                                                                                            //
      var hash = id.slice(0, 32);                                                                                      // 129
                                                                                                                       //
      if (hash in identiconCache) {                                                                                    // 131
        return identiconCache[hash];                                                                                   // 132
      }                                                                                                                // 133
                                                                                                                       //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     //
      var data = new Identicon(hash, 512).toString();                                                                  // 136
      var result = "data:image/svg+xml," + encodeURIComponent(data);                                                   // 137
      identiconCache[hash] = result;                                                                                   // 138
      return result;                                                                                                   // 139
    };                                                                                                                 // 140
                                                                                                                       //
    httpProtocol = window.location.protocol;                                                                           // 142
  })();                                                                                                                // 118
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                  // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            //
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              //
                                                                                                                       //
  if (!email) return undefined;                                                                                        // 163
                                                                                                                       //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                         //
  // on the same account.                                                                                              //
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
                                                                                                                       //
  var domain = (parts[1] || "").split(".");                                                                            // 170
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   //
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            //
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              //
    return [{ email: identity.services.google.email, primary: true }];                                                 // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{ email: identity.services.email.email, primary: true }];                                                  // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    var email = identity.services.ldap.rawAttrs[SandstormDb.prototype.getLdapEmailField()];                            // 266
    if (email) {                                                                                                       // 267
      return [{ email: email, primary: true }];                                                                        // 268
    }                                                                                                                  // 269
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 270
    return [{ email: identity.services.saml.email, primary: true }];                                                   // 271
  }                                                                                                                    // 272
                                                                                                                       //
  return [];                                                                                                           // 274
};                                                                                                                     // 275
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 277
  // Returns an array of identities which have the given email address as one of their verified                        //
  // addresses.                                                                                                        //
                                                                                                                       //
  check(email, String);                                                                                                // 281
                                                                                                                       //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                 //
    return !!_findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                    // 290
  });                                                                                                                  // 291
};                                                                                                                     // 292
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 294
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 295
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                     // 300
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 302
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 303
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 304
};                                                                                                                     // 306
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 308
  // Given an account user object, returns an array containing the ID of each identity linked to the                   //
  // account. Always returns the most recently added login identity first.                                             //
  if (user && user.loginIdentities) {                                                                                  // 311
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 312
  } else {                                                                                                             // 313
    return [];                                                                                                         // 314
  }                                                                                                                    // 315
};                                                                                                                     // 316
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 318
  // Given a user object, returns an array containing all email addresses associated with that user.                   //
  // Each entry in the array is an object of the form:                                                                 //
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    //
  //                                                                                                                   //
  // At most one entry in the result has `primary = true`.                                                             //
  //                                                                                                                   //
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         //
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         //
  //   on SandstormDb.                                                                                                 //
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 329
  var verifiedEmails = {};                                                                                             // 330
  var unverifiedEmails = {};                                                                                           // 331
                                                                                                                       //
  identityIds.forEach(function (id) {                                                                                  // 333
    var identity = Meteor.users.findOne({ _id: id });                                                                  // 334
    if (identity && identity.services) {                                                                               // 335
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 336
        if (verifiedEmail) {                                                                                           // 337
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 338
        }                                                                                                              // 339
      });                                                                                                              // 340
    }                                                                                                                  // 341
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 343
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 344
    }                                                                                                                  // 345
  });                                                                                                                  // 346
                                                                                                                       //
  var result = [];                                                                                                     // 348
  _.keys(verifiedEmails).map(function (email) {                                                                        // 349
    result.push({ email: email,                                                                                        // 350
      verified: true,                                                                                                  // 351
      primary: email === user.primaryEmail });                                                                         // 352
  });                                                                                                                  // 353
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 355
    if (!(email in verifiedEmails)) {                                                                                  // 356
      result.push({ email: email, verified: false });                                                                  // 356
    }                                                                                                                  // 356
  });                                                                                                                  // 357
                                                                                                                       //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                               //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 360
    result[0].primary = true;                                                                                          // 361
  }                                                                                                                    // 362
                                                                                                                       //
  return result;                                                                                                       // 364
};                                                                                                                     // 365
                                                                                                                       //
SandstormDb.prototype.addContact = function addContact(ownerId, identityId) {                                          // 367
  check(ownerId, String);                                                                                              // 368
  check(identityId, String);                                                                                           // 369
  var profile = this.getIdentity(identityId).profile;                                                                  // 370
  this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                     // 371
    ownerId: ownerId,                                                                                                  // 372
    petname: profile && profile.name,                                                                                  // 373
    created: new Date(),                                                                                               // 374
    identityId: identityId                                                                                             // 375
  });                                                                                                                  // 371
};                                                                                                                     // 377
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"user.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/user.js                                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Future = Npm.require("fibers/future");                                                                             // 18
                                                                                                                       //
userPictureUrl = function userPictureUrl(user) {                                                                       // 20
  if (user.services && !(user.profile && user.profile.picture)) {                                                      // 21
    // Try to determine user's avatar URL from login service.                                                          //
                                                                                                                       //
    var google = user.services.google;                                                                                 // 24
    if (google && google.picture) {                                                                                    // 25
      return google.picture;                                                                                           // 26
    }                                                                                                                  // 27
                                                                                                                       //
    var github = user.services.github;                                                                                 // 29
    if (github && github.id) {                                                                                         // 30
      return "https://avatars.githubusercontent.com/u/" + github.id;                                                   // 31
    }                                                                                                                  // 32
                                                                                                                       //
    // Note that we do NOT support Gravatar for email addresses because pinging Gravatar would be                      //
    // a data leak, revealing that the user has logged into this Sandstorm server. Google and                          //
    // Github are different because they are actually the identity providers, so they already know                     //
    // the user logged in.                                                                                             //
  }                                                                                                                    // 38
};                                                                                                                     // 39
                                                                                                                       //
fetchPicture = function fetchPicture(url) {                                                                            // 41
  try {                                                                                                                // 42
    var result = HTTP.get(url, {                                                                                       // 43
      npmRequestOptions: { encoding: null },                                                                           // 44
      timeout: 5000                                                                                                    // 45
    });                                                                                                                // 43
                                                                                                                       //
    var metadata = {};                                                                                                 // 48
                                                                                                                       //
    metadata.mimeType = result.headers["content-type"];                                                                // 50
    if (metadata.mimeType.lastIndexOf("image/png", 0) === -1 && metadata.mimeType.lastIndexOf("image/jpeg", 0) === -1) {
      throw new Error("unexpected Content-Type:", metadata.mimeType);                                                  // 53
    }                                                                                                                  // 54
                                                                                                                       //
    var enc = result.headers["content-encoding"];                                                                      // 56
    if (enc && enc !== "identity") {                                                                                   // 57
      metadata.encoding = enc;                                                                                         // 58
    }                                                                                                                  // 59
                                                                                                                       //
    return addStaticAsset(metadata, result.content);                                                                   // 61
  } catch (err) {                                                                                                      // 62
    console.error("failed to fetch user profile picture:", url, err.stack);                                            // 63
  }                                                                                                                    // 64
};                                                                                                                     // 65
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 67
  check(handle, String);                                                                                               // 68
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 69
});                                                                                                                    // 70
                                                                                                                       //
var localSandstormDb = new SandstormDb();                                                                              // 72
// TODO(someday): fix this when SandstormDb actually stores meaningful state on the object.                            //
// Unfortunately, onCreateUser doesn't pass along the connection object.                                               //
                                                                                                                       //
Accounts.onCreateUser(function (options, user) {                                                                       // 76
  if (user.loginIdentities) {                                                                                          // 77
    // it's an account                                                                                                 //
    check(user, { _id: String,                                                                                         // 79
      createdAt: Date,                                                                                                 // 80
      isAdmin: Match.Optional(Boolean),                                                                                // 81
      hasCompletedSignup: Match.Optional(Boolean),                                                                     // 82
      signupKey: Match.Optional(String),                                                                               // 83
      signupNote: Match.Optional(String),                                                                              // 84
      signupEmail: Match.Optional(String),                                                                             // 85
      expires: Match.Optional(Date),                                                                                   // 86
      appDemoId: Match.Optional(String),                                                                               // 87
      loginIdentities: [{ id: String }],                                                                               // 88
      nonloginIdentities: [{ id: String }] });                                                                         // 89
                                                                                                                       //
    if (localSandstormDb.isReferralEnabled()) {                                                                        // 91
      user.experiments = user.experiments || {};                                                                       // 92
      user.experiments = {                                                                                             // 93
        firstTimeBillingPrompt: Math.random() < 0.5 ? "control" : "test"                                               // 94
      };                                                                                                               // 93
      if (!("expires" in user)) {                                                                                      // 96
        sendReferralProgramNotification(user._id);                                                                     // 97
      }                                                                                                                // 98
    }                                                                                                                  // 99
                                                                                                                       //
    localSandstormDb.preinstallAppsForUser(user._id);                                                                  // 101
                                                                                                                       //
    return user;                                                                                                       // 103
  }                                                                                                                    // 104
                                                                                                                       //
  if (localSandstormDb.getOrganizationDisallowGuests() && !localSandstormDb.isIdentityInOrganization(user)) {          // 106
    throw new Meteor.Error(400, "User not in organization.");                                                          // 108
  }                                                                                                                    // 109
                                                                                                                       //
  // Check profile.                                                                                                    //
  if (options.profile) {                                                                                               // 112
    // TODO(cleanup): This check also appears in accounts-ui-methods.js.                                               //
    check(options.profile, Match.ObjectIncluding({                                                                     // 114
      name: Match.OneOf(null, Match.Optional(String)),                                                                 // 115
      handle: Match.Optional(ValidHandle),                                                                             // 116
      pronoun: Match.Optional(Match.OneOf("male", "female", "neutral", "robot"))                                       // 117
    }));                                                                                                               // 114
  }                                                                                                                    // 119
                                                                                                                       //
  check(options.unverifiedEmail, Match.Optional(String));                                                              // 121
                                                                                                                       //
  if (options.unverifiedEmail) {                                                                                       // 123
    user.unverifiedEmail = options.unverifiedEmail;                                                                    // 124
  }                                                                                                                    // 125
                                                                                                                       //
  user.profile = _.pick(options.profile || {}, "name", "handle", "pronouns");                                          // 127
                                                                                                                       //
  // Try downloading avatar.                                                                                           //
  var url = userPictureUrl(user);                                                                                      // 130
  if (url) {                                                                                                           // 131
    var assetId = fetchPicture(url);                                                                                   // 132
    if (assetId) {                                                                                                     // 133
      user.profile.picture = assetId;                                                                                  // 134
    }                                                                                                                  // 135
  }                                                                                                                    // 136
                                                                                                                       //
  var serviceUserId = void 0;                                                                                          // 138
  if (user.services && user.services.dev) {                                                                            // 139
    check(user.services.dev, { name: String, isAdmin: Boolean, hasCompletedSignup: Boolean });                         // 140
    serviceUserId = user.services.dev.name;                                                                            // 141
    user.profile.service = "dev";                                                                                      // 142
  } else if ("expires" in user) {                                                                                      // 143
    serviceUserId = user._id;                                                                                          // 144
    user.profile.service = "demo";                                                                                     // 145
  } else if (user.services && user.services.email) {                                                                   // 146
    check(user.services.email, {                                                                                       // 147
      email: String,                                                                                                   // 148
      tokens: [{                                                                                                       // 149
        digest: String,                                                                                                // 151
        algorithm: String,                                                                                             // 152
        createdAt: Date,                                                                                               // 153
        secureBox: Match.Optional({                                                                                    // 154
          version: Number,                                                                                             // 155
          salt: String,                                                                                                // 156
          iv: String,                                                                                                  // 157
          boxedValue: String                                                                                           // 158
        })                                                                                                             // 154
      }]                                                                                                               // 150
    });                                                                                                                // 147
    serviceUserId = user.services.email.email;                                                                         // 163
    user.profile.service = "email";                                                                                    // 164
  } else if (user.services && "google" in user.services) {                                                             // 165
    serviceUserId = user.services.google.id;                                                                           // 166
    user.profile.service = "google";                                                                                   // 167
  } else if (user.services && "github" in user.services) {                                                             // 168
    serviceUserId = user.services.github.id;                                                                           // 169
    user.profile.service = "github";                                                                                   // 170
  } else if (user.services && "ldap" in user.services) {                                                               // 171
    serviceUserId = user.services.ldap.id;                                                                             // 172
    user.profile.service = "ldap";                                                                                     // 173
  } else if (user.services && "saml" in user.services) {                                                               // 174
    serviceUserId = user.services.saml.id;                                                                             // 175
    user.profile.service = "saml";                                                                                     // 176
  } else {                                                                                                             // 177
    throw new Meteor.Error(400, "user does not have a recognized identity provider: " + JSON.stringify(user));         // 178
  }                                                                                                                    // 180
                                                                                                                       //
  user._id = Crypto.createHash("sha256").update(user.profile.service + ":" + serviceUserId).digest("hex");             // 182
                                                                                                                       //
  return user;                                                                                                         // 185
});                                                                                                                    // 186
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 188
  if (!attempt.allowed) {                                                                                              // 189
    return false;                                                                                                      // 190
  }                                                                                                                    // 191
                                                                                                                       //
  var db = attempt.connection.sandstormDb;                                                                             // 193
  var user = attempt.user;                                                                                             // 194
  if (user.loginIdentities) {                                                                                          // 195
    // it's an account                                                                                                 //
    if (db.getOrganizationDisallowGuests() && !db.isUserInOrganization(user)) {                                        // 197
      throw new Meteor.Error(403, "User not in organization.");                                                        // 199
    }                                                                                                                  // 200
                                                                                                                       //
    db.updateUserQuota(user); // This is a no-op if settings aren't enabled                                            // 202
  } else {                                                                                                             // 203
      if (db.getOrganizationDisallowGuests() && !db.isIdentityInOrganization(user)) {                                  // 204
        throw new Meteor.Error(403, "User not in organization.");                                                      // 206
      }                                                                                                                // 207
    }                                                                                                                  // 208
                                                                                                                       //
  return true;                                                                                                         // 210
});                                                                                                                    // 211
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"migrations.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/migrations.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Minimal tooling for doing run-at-least-once, ordered migrations.                                                    //
//                                                                                                                     //
// Because migrations can experience partial failure and likely have                                                   //
// side-effects, we should be careful to make sure all migrations are                                                  //
// idempotent and safe to accidentally run multiple times.                                                             //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 7
var Url = Npm.require("url");                                                                                          // 8
var Crypto = Npm.require("crypto");                                                                                    // 9
                                                                                                                       //
var localSandstormDb = new SandstormDb();                                                                              // 11
// TODO(someday): fix this when SandstormDb actually stores meaningful state on the object.                            //
                                                                                                                       //
var updateLoginStyleToRedirect = function updateLoginStyleToRedirect() {                                               // 14
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 15
  ["google", "github"].forEach(function (serviceName) {                                                                // 16
    var config = configurations.findOne({ service: serviceName });                                                     // 17
    if (config && config.loginStyle !== "redirect") {                                                                  // 18
      configurations.update({ service: serviceName }, { $set: { loginStyle: "redirect" } });                           // 19
    }                                                                                                                  // 20
  });                                                                                                                  // 21
};                                                                                                                     // 22
                                                                                                                       //
var enableLegacyOAuthProvidersIfNotInSettings = function enableLegacyOAuthProvidersIfNotInSettings() {                 // 24
  // In the before time, Google and Github login were enabled by default.                                              //
  //                                                                                                                   //
  // This actually didn't make much sense, required the first user to configure                                        //
  // OAuth, and had some trust-the-first-user properties that weren't totally                                          //
  // secure.                                                                                                           //
  //                                                                                                                   //
  // Now, we have admin-token, so we wish to disable all logins by default                                             //
  // (since they need to be configured anyway) but since users may have never                                          //
  // explicitly told Sandstorm that Google or Github login should be enabled,                                          //
  // we can't just use the value in the Settings collection, since it might                                            //
  // never have been set.                                                                                              //
  //                                                                                                                   //
  // Thus, if the service is configured but absent from Settings, we should                                            //
  // explicitly enable it in Settings, and then the rest of the logic can just                                         //
  // depend on what value is in Settings and default to false without breaking                                         //
  // user installations.                                                                                               //
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 41
  ["google", "github"].forEach(function (serviceName) {                                                                // 42
    var config = configurations.findOne({ service: serviceName });                                                     // 43
    var serviceConfig = Settings.findOne({ _id: serviceName });                                                        // 44
    if (config && !serviceConfig) {                                                                                    // 45
      // Only explicitly enable the login service if:                                                                  //
      // 1) the service is already configured                                                                          //
      // 2) there is no sandstorm configuration already present (the user was                                          //
      //    using the previous default behavior).                                                                      //
      Settings.insert({ _id: serviceName, value: true });                                                              // 50
    }                                                                                                                  // 51
  });                                                                                                                  // 52
};                                                                                                                     // 53
                                                                                                                       //
var denormalizeInviteInfo = function denormalizeInviteInfo() {                                                         // 55
  // When a user is invited via a signup token, the `signupKey` field of their user table entry                        //
  // has always been populated to indicate the key they used. This points into the SignupKeys table                    //
  // which has more information about the key, namely a freeform note entered by the admin when                        //
  // they created the key. In the case that the email invite form was used, the note has the form                      //
  // "E-mail invite to <address>".                                                                                     //
  //                                                                                                                   //
  // Later, we decided it was useful to indicate in the users table visible to the admin                               //
  // information about the invite terms. Namely, for email invites we want to show the address                         //
  // and for others we want to show the note. To make this efficient, fields `signupNote` and                          //
  // `signupEmail` were added to the users table. We can backfill these values by denormalizing                        //
  // from the SignupKeys table.                                                                                        //
                                                                                                                       //
  Meteor.users.find().forEach(function (user) {                                                                        // 68
    if (user.signupKey && typeof user.signupKey === "string" && user.signupKey !== "admin") {                          // 69
      var signupInfo = SignupKeys.findOne(user.signupKey);                                                             // 70
      if (signupInfo && signupInfo.note) {                                                                             // 71
        var newFields = { signupNote: signupInfo.note };                                                               // 72
                                                                                                                       //
        var prefix = "E-mail invite to ";                                                                              // 74
        if (signupInfo.note.lastIndexOf(prefix) === 0) {                                                               // 75
          newFields.signupEmail = signupInfo.note.slice(prefix.length);                                                // 76
        }                                                                                                              // 77
                                                                                                                       //
        Meteor.users.update(user._id, { $set: newFields });                                                            // 79
      }                                                                                                                // 80
    }                                                                                                                  // 81
  });                                                                                                                  // 82
};                                                                                                                     // 83
                                                                                                                       //
function mergeRoleAssignmentsIntoApiTokens() {                                                                         // 85
  RoleAssignments.find().forEach(function (roleAssignment) {                                                           // 86
    ApiTokens.insert({                                                                                                 // 87
      grainId: roleAssignment.grainId,                                                                                 // 88
      userId: roleAssignment.sharer,                                                                                   // 89
      roleAssignment: roleAssignment.roleAssignment,                                                                   // 90
      petname: roleAssignment.petname,                                                                                 // 91
      created: roleAssignment.created,                                                                                 // 92
      owner: {                                                                                                         // 93
        user: {                                                                                                        // 94
          userId: roleAssignment.recipient,                                                                            // 95
          title: roleAssignment.title                                                                                  // 96
        }                                                                                                              // 94
      }                                                                                                                // 93
    });                                                                                                                // 87
  });                                                                                                                  // 100
}                                                                                                                      // 101
                                                                                                                       //
function fixOasisStorageUsageStats() {}                                                                                // 103
// This migration only pertained to Oasis and it was successfully applied there. Since it referred                     //
// to some global variables that we later wanted to remove and/or rename, we've since replaced it                      //
// with a no-op.                                                                                                       //
                                                                                                                       //
function fetchProfilePictures() {                                                                                      // 108
  Meteor.users.find({}).forEach(function (user) {                                                                      // 109
    var url = userPictureUrl(user);                                                                                    // 110
    if (url) {                                                                                                         // 111
      console.log("Fetching user picture:", url);                                                                      // 112
      var assetId = fetchPicture(url);                                                                                 // 113
      if (assetId) {                                                                                                   // 114
        Meteor.users.update(user._id, { $set: { "profile.picture": assetId } });                                       // 115
      }                                                                                                                // 116
    }                                                                                                                  // 117
  });                                                                                                                  // 118
}                                                                                                                      // 119
                                                                                                                       //
function assignPlans() {                                                                                               // 121
  if (localSandstormDb.isReferralEnabled() && SandstormDb.paymentsMigrationHook) {                                     // 122
    SandstormDb.paymentsMigrationHook(SignupKeys, Plans.find().fetch());                                               // 123
  }                                                                                                                    // 124
}                                                                                                                      // 125
                                                                                                                       //
function removeKeyrings() {                                                                                            // 127
  // These blobs full of public keys were not intended to find their way into mongo and while                          //
  // harmless they slow things down because they're huge. Remove them.                                                 //
  Packages.update({ "manifest.metadata.pgpKeyring": { $exists: true } }, { $unset: { "manifest.metadata.pgpKeyring": "" } }, { multi: true });
}                                                                                                                      // 133
                                                                                                                       //
function useLocalizedTextInUserActions() {                                                                             // 135
  function toLocalizedText(newObj, oldObj, field) {                                                                    // 136
    if (field in oldObj) {                                                                                             // 137
      if (typeof oldObj[field] === "string") {                                                                         // 138
        newObj[field] = { defaultText: oldObj[field] };                                                                // 139
      } else {                                                                                                         // 140
        newObj[field] = oldObj[field];                                                                                 // 141
      }                                                                                                                // 142
    }                                                                                                                  // 143
  }                                                                                                                    // 144
                                                                                                                       //
  UserActions.find({}).forEach(function (userAction) {                                                                 // 146
    var fields = {};                                                                                                   // 147
    toLocalizedText(fields, userAction, "appTitle");                                                                   // 148
    toLocalizedText(fields, userAction, "title");                                                                      // 149
    toLocalizedText(fields, userAction, "nounPhrase");                                                                 // 150
    UserActions.update(userAction._id, { $set: fields });                                                              // 151
  });                                                                                                                  // 152
}                                                                                                                      // 153
                                                                                                                       //
function verifyAllPgpSignatures() {                                                                                    // 155
  Packages.find({}).forEach(function (pkg) {                                                                           // 156
    try {                                                                                                              // 157
      console.log("checking PGP signature for package:", pkg._id);                                                     // 158
      var info = waitPromise(globalBackend.cap().tryGetPackage(pkg._id));                                              // 159
      if (info.authorPgpKeyFingerprint) {                                                                              // 160
        console.log("  " + info.authorPgpKeyFingerprint);                                                              // 161
        Packages.update(pkg._id, { $set: { authorPgpKeyFingerprint: info.authorPgpKeyFingerprint } });                 // 162
      } else {                                                                                                         // 164
        console.log("  no signature");                                                                                 // 165
      }                                                                                                                // 166
    } catch (err) {                                                                                                    // 167
      console.error(err.stack);                                                                                        // 168
    }                                                                                                                  // 169
  });                                                                                                                  // 170
}                                                                                                                      // 171
                                                                                                                       //
function splitUserIdsIntoAccountIdsAndIdentityIds() {                                                                  // 173
  Meteor.users.find().forEach(function (user) {                                                                        // 174
    var identity = {};                                                                                                 // 175
    var serviceUserId = void 0;                                                                                        // 176
    if ("devName" in user) {                                                                                           // 177
      identity.service = "dev";                                                                                        // 178
      serviceUserId = user.devName;                                                                                    // 179
    } else if ("expires" in user) {                                                                                    // 180
      identity.service = "demo";                                                                                       // 181
      serviceUserId = user._id;                                                                                        // 182
    } else if (user.services && "google" in user.services) {                                                           // 183
      identity.service = "google";                                                                                     // 184
      if (user.services.google.email && user.services.google.verified_email) {                                         // 185
        // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                          //
        identity.verifiedEmail = user.services.google.email;                                                           // 186
      }                                                                                                                // 187
                                                                                                                       //
      serviceUserId = user.services.google.id;                                                                         // 189
    } else if (user.services && "github" in user.services) {                                                           // 190
      identity.service = "github";                                                                                     // 191
      identity.unverifiedEmail = user.services.github.email;                                                           // 192
      serviceUserId = user.services.github.id;                                                                         // 193
    } else if (user.services && "emailToken" in user.services) {                                                       // 194
      identity.service = "emailToken";                                                                                 // 195
      identity.verifiedEmail = user.services.emailToken.email;                                                         // 196
      serviceUserId = user.services.emailToken.email;                                                                  // 197
    }                                                                                                                  // 198
                                                                                                                       //
    identity.id = Crypto.createHash("sha256").update(identity.service + ":" + serviceUserId).digest("hex");            // 200
                                                                                                                       //
    if (user.profile) {                                                                                                // 203
      if (user.profile.name) {                                                                                         // 204
        identity.name = user.profile.name;                                                                             // 205
      }                                                                                                                // 206
                                                                                                                       //
      if (user.profile.handle) {                                                                                       // 208
        identity.handle = user.profile.handle;                                                                         // 209
      }                                                                                                                // 210
                                                                                                                       //
      if (user.profile.picture) {                                                                                      // 212
        identity.picture = user.profile.picture;                                                                       // 213
      }                                                                                                                // 214
                                                                                                                       //
      if (user.profile.pronoun) {                                                                                      // 216
        identity.pronoun = user.profile.pronoun;                                                                       // 217
      }                                                                                                                // 218
                                                                                                                       //
      if (user.profile.email) {                                                                                        // 220
        identity.unverifiedEmail = user.profile.email;                                                                 // 221
      }                                                                                                                // 222
    }                                                                                                                  // 223
                                                                                                                       //
    identity.main = true;                                                                                              // 225
                                                                                                                       //
    Meteor.users.update(user._id, { $set: { identities: [identity] } });                                               // 227
                                                                                                                       //
    Grains.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                       // 229
    Sessions.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                     // 230
    ApiTokens.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                    // 231
    ApiTokens.update({ "owner.user.userId": user._id }, { $set: { "owner.user.identityId": identity.id } }, { multi: true });
    ApiTokens.update({ "owner.grain.introducerUser": user._id }, { $set: { "owner.grain.introducerIdentity": identity.id } }, { multi: true });
                                                                                                                       //
    while (ApiTokens.update({ "requirements.permissionsHeld.userId": user._id }, { $set: { "requirements.$.permissionsHeld.identityId": identity.id },
      $unset: { "requirements.$.permissionsHeld.userId": 1 } }, { multi: true }) > 0) {}                               // 243
    // The `$` operatorer modifies the first element in the array that matches the query. Since                        //
    // there may be many matches, we need to repeat until no documents are modified.                                   //
  });                                                                                                                  // 248
                                                                                                                       //
  ApiTokens.remove({ userInfo: { $exists: true } });                                                                   // 250
  // We've renamed `Grain.UserInfo.userId` to `Grain.userInfo.identityId`. The only place                              //
  // that this field could show up in the database was in this deprecated, no-longer-functional                        //
  // form of API token.                                                                                                //
}                                                                                                                      // 254
                                                                                                                       //
function appUpdateSettings() {                                                                                         // 256
  Settings.insert({ _id: "appMarketUrl", value: "https://apps.sandstorm.io" });                                        // 257
  Settings.insert({ _id: "appIndexUrl", value: "https://app-index.sandstorm.io" });                                    // 258
  Settings.insert({ _id: "appUpdatesEnabled", value: true });                                                          // 259
}                                                                                                                      // 260
                                                                                                                       //
function moveDevAndEmailLoginDataIntoIdentities() {                                                                    // 262
  Meteor.users.find().forEach(function (user) {                                                                        // 263
    if (user.identities.length != 1) {                                                                                 // 264
      throw new Error("User does not have exactly one identity: ", user);                                              // 265
    }                                                                                                                  // 266
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 268
    if (Match.test(identity.service, Object)) {                                                                        // 269
      return;                                                                                                          // 269
    } // Already migrated.                                                                                             // 269
                                                                                                                       //
    var newIdentity = _.pick(identity, "id", "main", "noLogin", "verifiedEmail", "unverifiedEmail");                   // 271
    newIdentity.profile = _.pick(identity, "name", "handle", "picture", "pronoun");                                    // 272
                                                                                                                       //
    var serviceObject = {};                                                                                            // 274
    var fieldsToUnset = {};                                                                                            // 275
                                                                                                                       //
    if (identity.service === "dev") {                                                                                  // 277
      serviceObject.name = user.devName;                                                                               // 278
      fieldsToUnset.devName = 1;                                                                                       // 279
    } else if (identity.service === "emailToken") {                                                                    // 280
      serviceObject.tokens = user.services.emailToken.tokens;                                                          // 281
      serviceObject.email = user.services.emailToken.email;                                                            // 282
      fieldsToUnset["services.emailToken"] = 1;                                                                        // 283
    }                                                                                                                  // 284
                                                                                                                       //
    newIdentity.service = {};                                                                                          // 286
    newIdentity.service[identity.service] = serviceObject;                                                             // 287
                                                                                                                       //
    var modifier = { $set: { identities: [newIdentity] } };                                                            // 289
    if (Object.keys(fieldsToUnset).length > 0) {                                                                       // 290
      modifier.$unset = fieldsToUnset;                                                                                 // 291
    }                                                                                                                  // 292
                                                                                                                       //
    Meteor.users.update({ _id: user._id }, modifier);                                                                  // 294
  });                                                                                                                  // 295
}                                                                                                                      // 296
                                                                                                                       //
function repairEmailIdentityIds() {                                                                                    // 298
  Meteor.users.find({ "identities.service.emailToken": { $exists: 1 } }).forEach(function (user) {                     // 299
    if (user.identities.length != 1) {                                                                                 // 300
      throw new Error("User does not have exactly one identity: ", user);                                              // 301
    }                                                                                                                  // 302
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 304
    var newIdentity = _.pick(identity, "main", "noLogin", "verifiedEmail", "unverifiedMail", "profile");               // 305
    newIdentity.service = { email: identity.service.emailToken };                                                      // 307
    newIdentity.id = Crypto.createHash("sha256").update("email:" + identity.service.emailToken.email).digest("hex");   // 308
                                                                                                                       //
    Grains.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });             // 311
    Sessions.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });           // 312
    ApiTokens.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });          // 313
    ApiTokens.update({ "owner.user.identityId": identity.id }, { $set: { "owner.user.identityId": newIdentity.id } }, { multi: true });
    ApiTokens.update({ "owner.grain.introducerIdentity": identity.id }, { $set: { "owner.grain.introducerIdentity": newIdentity.id } }, { multi: true });
                                                                                                                       //
    while (ApiTokens.update({ "requirements.permissionsHeld.identityId": identity.id }, { $set: { "requirements.$.permissionsHeld.identityId": newIdentity.id } }, { multi: true }) > 0) {}
                                                                                                                       //
    Meteor.users.update({ _id: user._id }, { $set: { identities: [newIdentity] } });                                   // 327
  });                                                                                                                  // 328
}                                                                                                                      // 329
                                                                                                                       //
function splitAccountUsersAndIdentityUsers() {                                                                         // 331
  Meteor.users.find({ identities: { $exists: true } }).forEach(function (user) {                                       // 332
    if (user.identities.length != 1) {                                                                                 // 333
      throw new Error("User does not have exactly one identity: ", user);                                              // 334
    }                                                                                                                  // 335
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 337
    var identityUser = _.pick(user, "createdAt", "lastActive", "expires");                                             // 338
    identityUser._id = identity.id;                                                                                    // 339
    identityUser.profile = identity.profile;                                                                           // 340
    _.extend(identityUser, _.pick(identity, "unverifiedEmail"));                                                       // 341
    identityUser.profile.service = Object.keys(identity.service)[0];                                                   // 342
                                                                                                                       //
    // Updating this user needs to be a two step process because the `services` field typically                        //
    // contains subfields that are constrained to be unique by Mongo indices.                                          //
    identityUser.stagedServices = _.omit(user.services, "resume");                                                     // 346
    if (identity.service.dev) {                                                                                        // 347
      identityUser.stagedServices.dev = identity.service.dev;                                                          // 348
    } else if (identity.service.email) {                                                                               // 349
      identityUser.stagedServices.email = identity.service.email;                                                      // 350
    }                                                                                                                  // 351
                                                                                                                       //
    var accountUser = _.pick(user, "_id", "createdAt", "lastActive", "expires", "isAdmin", "signupKey", "signupNote", "signupEmail", "plan", "storageUsage", "isAppDemoUser", "appDemoId", "payments", "dailySentMailCount", "hasCompletedSignup");
    accountUser.loginIdentities = [_.pick(identity, "id")];                                                            // 357
    accountUser.nonloginIdentities = [];                                                                               // 358
    if (user.services && user.services.resume) {                                                                       // 359
      accountUser.services = { resume: user.services.resume };                                                         // 360
    }                                                                                                                  // 361
                                                                                                                       //
    accountUser.stashedOldUser = user;                                                                                 // 363
                                                                                                                       //
    ApiTokens.update({ identityId: identityUser._id }, { $set: { accountId: user._id } }, { multi: true });            // 365
                                                                                                                       //
    Meteor.users.upsert({ _id: identityUser._id }, identityUser);                                                      // 368
    Meteor.users.update({ _id: user._id }, accountUser);                                                               // 369
  });                                                                                                                  // 370
                                                                                                                       //
  Meteor.users.find({ stagedServices: { $exists: true } }).forEach(function (identity) {                               // 372
    Meteor.users.update({ _id: identity._id }, { $unset: { stagedServices: 1 },                                        // 373
      $set: { services: identity.stagedServices } });                                                                  // 374
  });                                                                                                                  // 375
}                                                                                                                      // 376
                                                                                                                       //
function populateContactsFromApiTokens() {                                                                             // 378
  ApiTokens.find({ "owner.user.identityId": { $exists: 1 },                                                            // 379
    accountId: { $exists: 1 } }).forEach(function (token) {                                                            // 380
    var identityId = token.owner.user.identityId;                                                                      // 381
    var identity = SandstormDb.prototype.getIdentity(identityId);                                                      // 382
    if (identity) {                                                                                                    // 383
      var profile = identity.profile;                                                                                  // 384
      Contacts.upsert({ ownerId: token.accountId, identityId: identityId }, {                                          // 385
        ownerId: token.accountId,                                                                                      // 386
        petname: profile && profile.name,                                                                              // 387
        created: new Date(),                                                                                           // 388
        identityId: identityId,                                                                                        // 389
        profile: profile                                                                                               // 390
      });                                                                                                              // 385
    }                                                                                                                  // 392
  });                                                                                                                  // 393
}                                                                                                                      // 394
                                                                                                                       //
function cleanUpApiTokens() {                                                                                          // 396
  // The `splitUserIdsIntoAccountIdsAndIdentityIds()` migration only added `identityId` in cases                       //
  // where the user still existed in the database.                                                                     //
  ApiTokens.remove({ userId: { $exists: true }, identityId: { $exists: false } });                                     // 399
  ApiTokens.remove({ "owner.user.userId": { $exists: true },                                                           // 400
    "owner.user.identityId": { $exists: false } });                                                                    // 401
                                                                                                                       //
  // For a while we were accidentally setting `appIcon` instead of `icon`.                                             //
  ApiTokens.find({ "owner.user.denormalizedGrainMetadata.appIcon": { $exists: true } }).forEach(function (apiToken) {  // 404
    var icon = apiToken.owner.user.denormalizedGrainMetadata.appIcon;                                                  // 406
    ApiTokens.update({ _id: apiToken._id }, { $set: { "owner.user.denormalizedGrainMetadata.icon": icon },             // 407
      $unset: { "owner.user.denormalizedGrainMetadata.appIcon": true } });                                             // 409
  });                                                                                                                  // 410
                                                                                                                       //
  // For a while the `identityId` field of child UiView tokens was not getting set.                                    //
  function repairChain(parentToken) {                                                                                  // 413
    ApiTokens.find({ parentToken: parentToken._id, grainId: { $exists: true },                                         // 414
      identityId: { $exists: false } }).forEach(function (childToken) {                                                // 415
      ApiTokens.update({ _id: childToken._id }, { $set: { identityId: parentToken.identityId } });                     // 416
      repairChain(childToken);                                                                                         // 417
    });                                                                                                                // 418
  }                                                                                                                    // 419
                                                                                                                       //
  ApiTokens.find({ grainId: { $exists: true }, identityId: { $exists: true },                                          // 421
    parentToken: { $exists: false } }).forEach(repairChain);                                                           // 422
}                                                                                                                      // 423
                                                                                                                       //
function initServerTitleAndReturnAddress() {                                                                           // 425
  var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                             // 426
  Settings.insert({ _id: "serverTitle", value: hostname });                                                            // 427
  Settings.insert({ _id: "returnAddress", value: "no-reply@" + hostname });                                            // 428
}                                                                                                                      // 429
                                                                                                                       //
function sendReferralNotifications() {                                                                                 // 431
  if (localSandstormDb.isReferralEnabled()) {                                                                          // 432
    Meteor.users.find({                                                                                                // 433
      loginIdentities: { $exists: true },                                                                              // 434
      expires: { $exists: false }                                                                                      // 435
    }, { fields: { _id: 1 } }).forEach(function (user) {                                                               // 433
      sendReferralProgramNotification(user._id);                                                                       // 437
    });                                                                                                                // 438
  }                                                                                                                    // 439
}                                                                                                                      // 440
                                                                                                                       //
function assignBonuses() {                                                                                             // 442
  if (localSandstormDb.isReferralEnabled() && SandstormDb.bonusesMigrationHook) {                                      // 443
    SandstormDb.bonusesMigrationHook();                                                                                // 444
  }                                                                                                                    // 445
}                                                                                                                      // 446
                                                                                                                       //
function splitSmtpUrl() {                                                                                              // 448
  var smtpUrlSetting = Settings.findOne({ _id: "smtpUrl" });                                                           // 449
  var smtpUrl = smtpUrlSetting ? smtpUrlSetting.value : process.env.MAIL_URL;                                          // 450
  var returnAddress = Settings.findOne({ _id: "returnAddress" });                                                      // 451
                                                                                                                       //
  // Default values.                                                                                                   //
  var smtpConfig = {                                                                                                   // 454
    hostname: "localhost",                                                                                             // 455
    port: "25",                                                                                                        // 456
    auth: undefined,                                                                                                   // 457
    returnAddress: returnAddress.value                                                                                 // 458
  };                                                                                                                   // 454
                                                                                                                       //
  var parsed = void 0;                                                                                                 // 461
  try {                                                                                                                // 462
    parsed = smtpUrl && Url.parse(smtpUrl);                                                                            // 463
  } catch (e) {}                                                                                                       // 464
                                                                                                                       //
  if (parsed) {                                                                                                        // 466
    // If there was a SMTP URL previously defined, import its data.                                                    //
    var auth = undefined;                                                                                              // 468
    if (parsed.auth) {                                                                                                 // 469
      var colonIndex = parsed.auth.indexOf(":");                                                                       // 470
      var user = undefined;                                                                                            // 471
      var pass = undefined;                                                                                            // 472
      if (colonIndex !== -1) {                                                                                         // 473
        user = parsed.auth.slice(0, colonIndex);                                                                       // 474
        pass = parsed.auth.slice(colonIndex + 1);                                                                      // 475
      }                                                                                                                // 476
                                                                                                                       //
      auth = {                                                                                                         // 478
        user: user,                                                                                                    // 479
        pass: pass                                                                                                     // 480
      };                                                                                                               // 478
    }                                                                                                                  // 482
                                                                                                                       //
    // Override defaults with previous config's values.                                                                //
    smtpConfig.hostname = parsed.hostname || "localhost";                                                              // 485
    smtpConfig.port = parsed.port || "25";                                                                             // 486
    smtpConfig.auth = auth;                                                                                            // 487
  }                                                                                                                    // 488
                                                                                                                       //
  Settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                                       // 490
  Settings.remove({ _id: "returnAddress" });                                                                           // 491
  Settings.remove({ _id: "smtpUrl" });                                                                                 // 492
}                                                                                                                      // 493
                                                                                                                       //
function smtpPortShouldBeNumber() {                                                                                    // 495
  var entry = Settings.findOne({ _id: "smtpConfig" });                                                                 // 496
  if (entry) {                                                                                                         // 497
    var setting = entry.value;                                                                                         // 498
    if (setting.port) {                                                                                                // 499
      setting.port = _.isNumber(setting.port) ? setting.port : parseInt(setting.port);                                 // 500
      Settings.upsert({ _id: "smtpConfig" }, { value: setting });                                                      // 501
    }                                                                                                                  // 502
  }                                                                                                                    // 503
}                                                                                                                      // 504
                                                                                                                       //
function consolidateOrgSettings() {                                                                                    // 506
  var orgGoogleDomain = Settings.findOne({ _id: "organizationGoogle" });                                               // 507
  var orgEmailDomain = Settings.findOne({ _id: "organizationEmail" });                                                 // 508
  var orgLdap = Settings.findOne({ _id: "organizationLdap" });                                                         // 509
  var orgSaml = Settings.findOne({ _id: "organizationSaml" });                                                         // 510
                                                                                                                       //
  var orgMembership = {                                                                                                // 512
    google: {                                                                                                          // 513
      enabled: orgGoogleDomain ? !!orgGoogleDomain.value : false,                                                      // 514
      domain: orgGoogleDomain ? orgGoogleDomain.value : ""                                                             // 515
    },                                                                                                                 // 513
    email: {                                                                                                           // 517
      enabled: orgEmailDomain ? !!orgEmailDomain.value : false,                                                        // 518
      domain: orgEmailDomain ? orgEmailDomain.value : ""                                                               // 519
    },                                                                                                                 // 517
    ldap: {                                                                                                            // 521
      enabled: orgLdap ? orgLdap.value : false                                                                         // 522
    },                                                                                                                 // 521
    saml: {                                                                                                            // 524
      enabled: orgSaml ? orgSaml.value : false                                                                         // 525
    }                                                                                                                  // 524
  };                                                                                                                   // 512
                                                                                                                       //
  Settings.upsert({ _id: "organizationMembership" }, { value: orgMembership });                                        // 529
  Settings.remove({ _id: "organizationGoogle" });                                                                      // 530
  Settings.remove({ _id: "organizationEmail" });                                                                       // 531
  Settings.remove({ _id: "organizationLdap" });                                                                        // 532
  Settings.remove({ _id: "organizationSaml" });                                                                        // 533
}                                                                                                                      // 534
                                                                                                                       //
function unsetSmtpDefaultHostnameIfNoUsersExist() {                                                                    // 536
  // We don't actually want to have the default hostname "localhost" set.                                              //
  // If the user has already finished configuring their server, then this migration should do                          //
  // nothing (since we might break their deployment), but for new installs (which will have no users                   //
  // at the time this migration runs) we'll unset the hostname if it's still the previously-filled                     //
  // default value.                                                                                                    //
  var hasUsers = Meteor.users.findOne();                                                                               // 542
  if (!hasUsers) {                                                                                                     // 543
    var entry = Settings.findOne({ _id: "smtpConfig" });                                                               // 544
    var smtpConfig = entry.value;                                                                                      // 545
    if (smtpConfig.hostname === "localhost") {                                                                         // 546
      smtpConfig.hostname = "";                                                                                        // 547
      Settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                                   // 548
    }                                                                                                                  // 549
  }                                                                                                                    // 550
}                                                                                                                      // 551
                                                                                                                       //
function extractLastUsedFromApiTokenOwner() {                                                                          // 553
  // We used to store lastUsed as a field on owner.user.  It makes more sense to store lastUsed on                     //
  // the apiToken as a whole.  This migration hoists such values from owner.user onto the apiToken                     //
  // itself.                                                                                                           //
  ApiTokens.find({ "owner.user": { $exists: true } }).forEach(function (token) {                                       // 557
    var lastUsed = token.owner.user.lastUsed;                                                                          // 558
    ApiTokens.update({ _id: token._id }, {                                                                             // 559
      $set: { lastUsed: lastUsed },                                                                                    // 560
      $unset: { "owner.user.lastUsed": true }                                                                          // 561
    });                                                                                                                // 559
  });                                                                                                                  // 563
}                                                                                                                      // 564
                                                                                                                       //
function setUpstreamTitles() {                                                                                         // 566
  // Initializes the `upstreamTitle` and `renamed` fields of `ApiToken.owner.user`.                                    //
                                                                                                                       //
  var apiTokensRaw = ApiTokens.rawCollection();                                                                        // 569
  var aggregateApiTokens = Meteor.wrapAsync(apiTokensRaw.aggregate, apiTokensRaw);                                     // 570
                                                                                                                       //
  // First, construct a list of all *shared* grains. We will need to do a separate update()                            //
  // for each of these, so we'd like to skip those which have nothing to update.                                       //
  var grainIds = aggregateApiTokens([{ $match: { "owner.user": { $exists: true }, grainId: { $exists: true } } }, { $group: { _id: "$grainId" } }]).map(function (grain) {
    return grain._id;                                                                                                  // 577
  });                                                                                                                  // 577
                                                                                                                       //
  var count = 0;                                                                                                       // 579
  Grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } }).forEach(function (grain) {                         // 580
    if (count % 100 == 0) {                                                                                            // 581
      console.log(count + " / " + grainIds.length);                                                                    // 582
    }                                                                                                                  // 583
                                                                                                                       //
    ++count;                                                                                                           // 585
                                                                                                                       //
    // For ApiTokens whose petname titles do not match the upstream title, we need to set                              //
    // `upstreamTitle` and `renamed`. We have no way of knowing which of the two names was the                         //
    // original name, so we don't know whether it was the owner or the receiver who renamed their                      //
    // copy post-sharaing. We assume it was the owner, because:                                                        //
    // 1. It's probably unusual for people to try to rename a grain they don't own.                                    //
    // 2. This results in UI that is reasonably non-confusing even if we guessed wrong. Namely,                        //
    //    the user sees "Owner's title (was: User's title)", which is reasonably OK even if it                         //
    //    was the user who had renamed their copy. They can rename it again if they like. On the                       //
    //    other hand, if we guessed wrongly in the other direction, the user would see                                 //
    //    "User's title (renamed from: Owners title)", which would be wrong if it was in fact the                      //
    //    owner who renamed post-sharing.                                                                              //
    ApiTokens.update({                                                                                                 // 598
      grainId: grain._id,                                                                                              // 599
      "owner.user.title": { $exists: true, $ne: grain.title }                                                          // 600
    }, { $set: { "owner.user.upstreamTitle": grain.title } }, { multi: true });                                        // 598
  });                                                                                                                  // 602
}                                                                                                                      // 603
                                                                                                                       //
function markAllRead() {                                                                                               // 605
  // Mark as "read" all grains and tokens that predate the creation of read/unread status.                             //
  // Otherwise it's pretty annoying to see all your old grains look like they have activity.                           //
                                                                                                                       //
  Grains.update({}, { $set: { ownerSeenAllActivity: true } }, { multi: true });                                        // 609
  ApiTokens.update({ "owner.user": { $exists: true } }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
}                                                                                                                      // 613
                                                                                                                       //
function clearAppIndex() {                                                                                             // 615
  // Due to a bug in the app update code, some app update notifications that the user accepted                         //
  // around July 9-16, 2016 may not have applied. We have no way of knowing exactly which updates                      //
  // the user accepted but didn't receive. Instead, to recover, we are clearing the local cache of                     //
  // the app index one time. This way, the next time the app index is re-fetched, the server will                      //
  // interpret all of the apps in the index as updated and will re-deliver notifications to                            //
  // everyone. This may mean users get notifications that they previously dismissed, but they can                      //
  // click "dismiss" again easily enough.                                                                              //
                                                                                                                       //
  AppIndex.remove({});                                                                                                 // 624
}                                                                                                                      // 625
                                                                                                                       //
function assignEmailVerifierIds() {                                                                                    // 627
  // Originally, the ID of an EmailVerifier was actually the _id of the root token from which it                       //
  // was restored. This was broken, though: Conceptually, it meant that you couldn't have a working                    //
  // EmailVerifier that had not been restore()d from disk. In practice, that wasn't a problem due                      //
  // to the fact that powerbox selections always involve a restore(), but a different problem                          //
  // existed: the capability returned by claimRequest() would return one ID, but after save()ing                       //
  // and restore()ing that capability, the ID would be different, because the new capability would                     //
  // be a copy -- not a child -- of the original. Additionally, the whole thing made various code                      //
  // ugly because it was puncturing layers of abstraction. So, we switched to doing the right                          //
  // thing: assigning an ID to the EmailVerifier on first creation and storing it separately.                          //
                                                                                                                       //
  ApiTokens.find({ "frontendRef.emailVerifier": { $exists: true } }).forEach(function (token) {                        // 638
    ApiTokens.update(token._id, { $set: { "frontendRef.emailVerifier.id": token._id } });                              // 639
  });                                                                                                                  // 640
}                                                                                                                      // 641
                                                                                                                       //
function startPreinstallingApps() {                                                                                    // 643
  // This isn't really a normal migration. It will run only on brand new servers, and it has to                        //
  // run after the `clearAppIndex` migration because it relies on populating AppIndex.                                 //
                                                                                                                       //
  var startPreinstallingAppsHelper = function startPreinstallingAppsHelper() {                                         // 647
    localSandstormDb.updateAppIndex();                                                                                 // 648
                                                                                                                       //
    var preinstalledApps = globalDb.collections.appIndex.find({ _id: {                                                 // 650
        $in: globalDb.getProductivitySuiteAppIds() }                                                                   // 651
    }).fetch();                                                                                                        // 650
    var appAndPackageIds = _.map(preinstalledApps, function (app) {                                                    // 653
      return {                                                                                                         // 654
        appId: app.appId,                                                                                              // 655
        packageId: app.packageId                                                                                       // 656
      };                                                                                                               // 654
    });                                                                                                                // 658
                                                                                                                       //
    localSandstormDb.setPreinstalledApps(appAndPackageIds);                                                            // 660
  };                                                                                                                   // 661
                                                                                                                       //
  if (!Meteor.settings["public"].isTesting && !localSandstormDb.allowDevAccounts()) {                                  // 663
    // We want preinstalling apps to run async and not block startup.                                                  //
    Meteor.setTimeout(startPreinstallingAppsHelper, 0);                                                                // 665
  }                                                                                                                    // 666
}                                                                                                                      // 667
                                                                                                                       //
function setNewServer() {                                                                                              // 669
  // This migration only applies to "old" servers. New servers will set                                                //
  // new_server_migrations_applied to false before any migrations run.                                                 //
  if (!Migrations.findOne({ _id: "new_server_migrations_applied" })) {                                                 // 672
    Migrations.insert({ _id: "new_server_migrations_applied", value: true });                                          // 673
  }                                                                                                                    // 674
}                                                                                                                      // 675
                                                                                                                       //
function backgroundFillInGrainSizes() {                                                                                // 677
  // Fill in sizes for all grains that don't have them. Since computing a grain size requires a                        //
  // directory walk, we don't want to do them all at once. Instead, we compute one a second until                      //
  // all grains have sizes.                                                                                            //
                                                                                                                       //
  try {                                                                                                                // 682
    var grain = Grains.findOne({ size: { $exists: false } }, { fields: { _id: 1, userId: 1 } });                       // 683
                                                                                                                       //
    if (grain) {                                                                                                       // 685
      // Compute size!                                                                                                 //
      try {                                                                                                            // 687
        var result = waitPromise(globalBackend.cap().getGrainStorageUsage(grain.userId, grain._id));                   // 688
        Grains.update({ _id: grain._id, size: { $exists: false } }, { $set: { size: parseInt(result.size) } });        // 690
      } catch (err) {                                                                                                  // 692
        if (err.kjType === "failed") {                                                                                 // 693
          // Backend had a problem. Maybe the grain doesn't actually exist on disk and the database                    //
          // is messed up. We'll set the size to zero and move on.                                                     //
          console.error("Error while backfilling grain size for", grain._id, ":", err.stack);                          // 696
          Grains.update({ _id: grain._id, size: { $exists: false } }, { $set: { size: 0 } });                          // 697
        } else {                                                                                                       // 698
          // Rethrow on disconnected / overloaded / unimplemented.                                                     //
          throw err;                                                                                                   // 700
        }                                                                                                              // 701
      }                                                                                                                // 702
                                                                                                                       //
      // Do another one in a second.                                                                                   //
      Meteor.setTimeout(backgroundFillInGrainSizes, 1000);                                                             // 705
    }                                                                                                                  // 706
  } catch (err) {                                                                                                      // 707
    // We'll just stop for now, to avoid spamming logs if this error persists. Next time the server                    //
    // restarts, the migration will continue.                                                                          //
    console.error("Error while backfilling grain sizes:", err.stack);                                                  // 710
  }                                                                                                                    // 711
}                                                                                                                      // 712
                                                                                                                       //
// This must come after all the functions named within are defined.                                                    //
// Only append to this list!  Do not modify or remove list entries;                                                    //
// doing so is likely change the meaning and semantics of user databases.                                              //
var MIGRATIONS = [updateLoginStyleToRedirect, enableLegacyOAuthProvidersIfNotInSettings, denormalizeInviteInfo, mergeRoleAssignmentsIntoApiTokens, fixOasisStorageUsageStats, fetchProfilePictures, assignPlans, removeKeyrings, useLocalizedTextInUserActions, verifyAllPgpSignatures, splitUserIdsIntoAccountIdsAndIdentityIds, appUpdateSettings, moveDevAndEmailLoginDataIntoIdentities, repairEmailIdentityIds, splitAccountUsersAndIdentityUsers, populateContactsFromApiTokens, cleanUpApiTokens, initServerTitleAndReturnAddress, sendReferralNotifications, assignBonuses, splitSmtpUrl, smtpPortShouldBeNumber, consolidateOrgSettings, unsetSmtpDefaultHostnameIfNoUsersExist, extractLastUsedFromApiTokenOwner, setUpstreamTitles, markAllRead, clearAppIndex, assignEmailVerifierIds, setNewServer];
                                                                                                                       //
var NEW_SERVER_STARTUP = [startPreinstallingApps];                                                                     // 750
                                                                                                                       //
function migrateToLatest() {                                                                                           // 754
  if (Meteor.settings.replicaNumber) {                                                                                 // 755
    (function () {                                                                                                     // 755
      // This is a replica. Wait for the first replica to perform migrations.                                          //
                                                                                                                       //
      console.log("Waiting for migrations on replica zero...");                                                        // 758
                                                                                                                       //
      var done = new Future();                                                                                         // 760
      var change = function change(doc) {                                                                              // 761
        console.log("Migrations applied elsewhere: " + doc.value + "/" + MIGRATIONS.length);                           // 762
        if (doc.value >= MIGRATIONS.length) done["return"]();                                                          // 763
      };                                                                                                               // 764
                                                                                                                       //
      var observer = Migrations.find({ _id: "migrations_applied" }).observe({                                          // 766
        added: change,                                                                                                 // 767
        changed: change                                                                                                // 768
      });                                                                                                              // 766
                                                                                                                       //
      var newServerDone = new Future();                                                                                // 771
      var newServerChange = function newServerChange(doc) {                                                            // 772
        if (doc.value) {                                                                                               // 773
          console.log("New server migrations applied elsewhere");                                                      // 774
          newServerDone["return"]();                                                                                   // 775
        }                                                                                                              // 776
      };                                                                                                               // 777
                                                                                                                       //
      var newServerObserver = Migrations.find({ _id: "new_server_migrations_applied" }).observe({                      // 779
        added: newServerChange,                                                                                        // 780
        changed: newServerChange                                                                                       // 781
      });                                                                                                              // 779
                                                                                                                       //
      done.wait();                                                                                                     // 784
      observer.stop();                                                                                                 // 785
      newServerDone.wait();                                                                                            // 786
      newServerObserver.stop();                                                                                        // 787
      console.log("Migrations have completed on replica zero.");                                                       // 788
    })();                                                                                                              // 755
  } else {                                                                                                             // 790
    var applied = Migrations.findOne({ _id: "migrations_applied" });                                                   // 791
    var start = void 0;                                                                                                // 792
    if (!applied) {                                                                                                    // 793
      // Migrations table is not yet seeded with a value.  This means it has                                           //
      // applied 0 migrations.  Persist this.                                                                          //
      Migrations.insert({ _id: "migrations_applied", value: 0 });                                                      // 796
      start = 0;                                                                                                       // 797
                                                                                                                       //
      // This also means this is a brand new server                                                                    //
      Migrations.insert({ _id: "new_server_migrations_applied", value: false });                                       // 800
    } else {                                                                                                           // 801
      start = applied.value;                                                                                           // 802
    }                                                                                                                  // 803
                                                                                                                       //
    console.log("Migrations already applied: " + start + "/" + MIGRATIONS.length);                                     // 805
                                                                                                                       //
    for (var i = start; i < MIGRATIONS.length; i++) {                                                                  // 807
      // Apply migration i, then record that migration i was successfully run.                                         //
      console.log("Applying migration " + (i + 1));                                                                    // 809
      MIGRATIONS[i]();                                                                                                 // 810
      Migrations.update({ _id: "migrations_applied" }, { $set: { value: i + 1 } });                                    // 811
      console.log("Applied migration " + (i + 1));                                                                     // 812
    }                                                                                                                  // 813
                                                                                                                       //
    if (!Migrations.findOne({ _id: "new_server_migrations_applied" }).value) {                                         // 815
      // new_server_migrations_applied is guaranteed to exist since we have a migration that                           //
      // ensures it.                                                                                                   //
      for (var _i = 0; _i < NEW_SERVER_STARTUP.length; _i++) {                                                         // 818
        console.log("Running new server startup function " + (_i + 1));                                                // 819
        NEW_SERVER_STARTUP[_i]();                                                                                      // 820
        console.log("Running new server startup function " + (_i + 1));                                                // 821
      }                                                                                                                // 822
                                                                                                                       //
      Migrations.update({ _id: "new_server_migrations_applied" }, { $set: { value: true } });                          // 824
    }                                                                                                                  // 825
                                                                                                                       //
    // Start background migrations.                                                                                    //
    backgroundFillInGrainSizes();                                                                                      // 828
  }                                                                                                                    // 829
}                                                                                                                      // 830
                                                                                                                       //
SandstormDb.prototype.migrateToLatest = migrateToLatest;                                                               // 832
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");
require("./node_modules/meteor/sandstorm-db/user.js");
require("./node_modules/meteor/sandstorm-db/migrations.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
